#include ".\object3d.h"
#include <iostream>
int Object3D::SOLID = 0;
int Object3D::WIRE = 1;
int Object3D::POINT = 2;
Object3D::Object3D(void)
{
	t = new Trekant*[1000];
	p = new Point3D*[1000];
	e = new Edge*[1000];
	nt = ne = np = 0;
	maxe = maxp = maxt = 1000;
}

Object3D::~Object3D(void)
{
}
int Object3D::FinnPunkt(Point3D *test)
{
	if(p[0]->d[2] == 0)
	{
		printf("Skal finne en som er lik [%lf, %lf, %lf]\n", test->d[0], test->d[1], test->d[2]);
		for(int i =0; i<np; i++)
		{
			printf("Tester mot [%lf, %lf, %lf]\n", p[i]->d[0], p[i]->d[1], p[i]->d[2]);
		}
		int a = -1; 
		while( a == -1 )
		{
			std::cin >> a;
		}
	}
	for(int i = 0; i < np; i++)
	{
		if(*test == *p[i]) return i;
	}
	
	
	return -1;
}
void Object3D::generer(Triangle **liste, int ant)
{
	
	for(int i = 0; i < ant; i++)
	{
		int pid[3];
		for(int j = 0; j < 3; j++)
		{
			pid[j] = leggTilPunkt(liste[i]->p[j]);
		}
		int ti = leggTilTrekant(new Trekant(pid[0], pid[1], pid[2], ne, ne+1, ne+2));
		
		Edge *temp0 = new Edge(pid[0], pid[1], ti, -1, ne+2, -1, ne+1, -1, dist(liste[i]->p[0], liste[i]->p[1]));
		Edge *temp1 = new Edge(pid[1], pid[2], ti, -1, ne, -1, ne+2, -1, dist(liste[i]->p[2], liste[i]->p[1]));
		Edge *temp2 = new Edge(pid[2], pid[0], ti, -1, ne+1, -1, ne, -1, dist(liste[i]->p[0], liste[i]->p[2]));
		leggTilEdge(temp0);
		leggTilEdge(temp1);
		leggTilEdge(temp2);
	}
	//printf("Har lagt til %d edger\n", ne);
	
	// Gr igjennom og fjerner duplikater og legger informasjonen sammen
	// For hvert duplikat punkt jeg finner, skal jeg fjerne det ene punktet, men ogs 
	// G igjennom alle trekanter og edger og endre til felles verdi
	int *verdier = new int[np];
	bool *slettet = new bool[np];
	for(int i = 0; i < np; i++)
	{
		verdier[i] = i;
		slettet[i] = false;
	}
	int nSlettet = 0;

	for(int i = 0; i < np; i++)
	{
		for(int j = i+1; j < np; j++)
		{
			if(slettet[j]) continue;
			if(*p[i] == *p[j])
			{
				// SKal fjerne duplikaten
				verdier[j] = verdier[i];
				for(int k = j+1; k < np; k++)
				{
					if(!slettet[k]) verdier[k] = verdier[k]-1;
					
				}
				slettet[j] = true;
				nSlettet++;
				
			}
		}
	}
	
	// Sletter duplikatene
	Point3D **ny = new Point3D*[maxp]; int k = 0;
	
	
	for(int i = 0; i < np; i++)
	{
	
		if(!slettet[i]) ny[k++] = p[i];
		else delete p[i];
	}

	delete[] p;
	np = k;
	p = ny;


	// Endrer indeks-pekerene til punktene i trekantene
	for(int i = 0; i < nt; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			t[i]->p[j] = verdier[t[i]->p[j]];
		}
	}


	// Endrer indeks-pekerene til punktene i edgene
	for(int i = 0; i < ne; i++)
	{
		e[i]->p[0] = verdier[e[i]->p[0]];
		e[i]->p[1] = verdier[e[i]->p[1]];
	}

	// Gr n igjennom og finner duplikate edger
	delete[] verdier;
	delete[] slettet;
	verdier = new int[ne];
	nSlettet = 0;
	slettet = new bool[ne];
	for(int i = 0; i < ne; i++)
	{
		verdier[i] = i;
		slettet[i] = false;
	}
	for(int i = 0; i < ne; i++)
	{
		for(int j = i+1; j < ne; j++)
		{
			if(slettet[j]) continue;
			if((e[i]->p[0] == e[j]->p[0] && e[i]->p[1] == e[j]->p[1]) || (e[i]->p[0] == e[j]->p[1] && e[i]->p[1] == e[j]->p[0]))
			{
				slettet[j] = true;
				verdier[j] = verdier[i];
				nSlettet++;
				// Slr sammen edgene
				// venstre-edger i e[j] blir hyre-edger i e[i]
				e[i]->t[1] = e[j]->t[0];
				e[i]->e[1] = e[j]->e[0];
				e[i]->e[3] = e[j]->e[2];
				for(int k = j+1; k < ne; k++)
				{
					if(!slettet[k]) verdier[k]--;
				}
				j = ne; // Skal bare finnes 2 duplikater av edger
			}
		}
	}

	// Gr gjennom alle trekanter og endrer indeks-pekerene til edgene
	for(int i = 0; i < nt; i++)
	{
		for(int j = 0; j < 3; j++)
		{
			t[i]->e[j] = verdier[t[i]->e[j]];
		}
	}


	// Sletter duplikater av edger
	Edge **nye = new Edge*[maxe];
	k = 0;
	for(int i = 0; i < ne; i++)
	{
		if(!slettet[i]) nye[k++] = e[i];
		else delete e[i];
	}
	ne = k;
	
	delete[] e;
	e = nye;
	
}

int  Object3D::leggTilPunkt(Point3D *pn)
{
	if(np == maxp)
	{
		Point3D **ny = new Point3D*[maxp*2];
		for(int i = 0; i < maxp; i++)
		{
			ny[i] = p[i];
		}
		delete[] p; p = ny;
		maxp *= 2;
	}
	p[np++] = pn;
	return np-1;
}
int Object3D::leggTilEdge(Edge *en)
{
	if(ne == maxe)
	{
		Edge **ny = new Edge*[maxe*2];
		for(int i = 0; i < maxe; i++)
		{
			ny[i] = e[i];
		}
		delete[] e; e = ny;
		maxe *= 2;
	}
	e[ne++] = en;
	return ne-1;
	
}
int Object3D::leggTilTrekant(Trekant *nyT)
{
	if(nt == maxt)
	{
		Trekant **ny = new Trekant*[maxt*2];
		for(int i = 0; i < maxt; i++)
		{
			ny[i] = t[i];
		}
		delete[] t;
		maxt *= 2;
		t = ny;
	}
	t[nt++] = nyT;
	return nt-1;
}
void Object3D::tegn()
{
	if(MODE == SOLID)
	{
		glBegin(GL_TRIANGLES);
		for(int i = 0; i < nt; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				Point3D *pp = p[t[i]->p[j]];
				glVertex3f(pp->d[0], pp->d[1], pp->d[2]);
			}
		}
		glEnd();
	}
	else if(MODE == WIRE)
	{
		glBegin(GL_LINES);
		for(int i = 0; i < ne; i++)
		{
			Point3D *a = p[e[i]->p[0]];
			Point3D *b = p[e[i]->p[1]];
			glVertex3f(a->d[0], a->d[1], a->d[2]);
			glVertex3f(b->d[0], b->d[1], b->d[2]);
		}
		glEnd();
	}
	else if(MODE == POINT)
	{
	}
}