#include "ParticleSystem.h"
#include <time.h>
double ParticleSystem::dt = 0.01;
int deleVerdi = 10;
double **tab;

int maxIt = 100, minIt = 10;

ParticleSystem::ParticleSystem(void)
{
	
}

ParticleSystem::~ParticleSystem(void)
{
}



void ParticleSystem::LagLaken()
{

	vekt = 1;
	tiden = 0;
	// Konstruerer et kvadratisk laken av partikler
	Edge::TYPE = Edge::STRETCH;
	int iii = 20;
	deleVerdi = 2 * iii;
	int hoyde = iii, bredde = iii;
	float y[2] = { 0.0f, 5.50f };
	float x[2] = { 0.0f, 5.50f };
	float z = -0.1;
	
	Point3D ***grid = new Point3D**[hoyde];
	for(int i = 0; i < hoyde; i++)
	{
		grid[i] = new Point3D*[bredde];
		float yValue = (y[1]-y[0])/hoyde * i;
		for(int j = 0; j < bredde; j++)
		{
			float xValue = (x[1]-x[0])/bredde * j;
			grid[i][j] = new Point3D(xValue, yValue, z);
		}
	}
	
	Triangle **t = new Triangle*[2*(bredde-1)*(hoyde-1)];
	int nt = 0;
	for(int i = 1; i < hoyde; i++)
	{
		for(int j = 1; j < bredde; j++)
		{
			t[nt++] = new Triangle(new Point3D(grid[i-1][j-1]), new Point3D(grid[i][j-1]), new Point3D(grid[i-1][j]));
			t[nt++] = new Triangle(new Point3D(grid[i][j-1]), new Point3D(grid[i][j]), new Point3D(grid[i-1][j]));
		}
	}

	 
	obj.generer(t, nt);
	nn = obj.ne;
	tab = new double*[3*obj.np];
	for(int i = 0; i < 3*obj.np; i++) tab[i] = new double[3*obj.np];
	
	printf("Er kommet til 1\n");
	Edge::TYPE = Edge::SHEAR;
	// Lager shear-krefter og legger dem til som ekstra-edges
	for(int i = 1; i < hoyde; i++)
	{
		for(int j = 1; j < bredde; j++)
		{
			int xi = obj.FinnPunkt(grid[i-1][j-1]);
			int xj = obj.FinnPunkt(grid[i][j]);

			double len = dist(grid[i-1][j-1], grid[i][j]);
			obj.leggTilEdge(new Edge(xi, xj, -1, -1, -1, -1, -1, -1, len));
		}
	}
	
	Edge::TYPE = Edge::BEND;
	// Lager bend krefter og legger dem til som ekstra-edges
	for(int i = 2; i < hoyde; i++)
	{
		for(int j = 2; j < bredde; j++)
		{
			int x[4];
			double len[3];
			x[0] = obj.FinnPunkt(grid[i-2][j-2]);
			x[1] = obj.FinnPunkt(grid[i-2][j]);
			x[2] = obj.FinnPunkt(grid[i][j-2]);
			x[3] = obj.FinnPunkt(grid[i][j]);

			len[0] = dist(grid[i][j], grid[i-2][j-2]);
			len[1] = dist(grid[i][j], grid[i-2][j]);
			len[2] = dist(grid[i][j], grid[i][j-2]);

			obj.leggTilEdge(new Edge(x[3], x[0], -1, -1, -1, -1, -1, -1, len[0]));
			obj.leggTilEdge(new Edge(x[3], x[1], -1, -1, -1, -1, -1, -1, len[1]));
			obj.leggTilEdge(new Edge(x[3], x[2], -1, -1, -1, -1, -1, -1, len[2]));
		}
	}

	for(int i = 2; i < hoyde; i++)
	{
		for(int j = 0; j < bredde-2; j++)
		{
			int x[2];
			double len[3];
			x[0] = obj.FinnPunkt(grid[i-2][j+2]);
			x[1] = obj.FinnPunkt(grid[i][j]);

			len[0] = dist(grid[i][j], grid[i-2][j+2]);

			obj.leggTilEdge(new Edge(x[1], x[0], -1, -1, -1, -1, -1, -1, len[0]));
		}
	}
	
	printf("Er kommet til 3\n");
	for(int i = 2; i < hoyde; i++)
	{
		int x[4];
		double len[2];
		x[0] = obj.FinnPunkt(grid[i-2][0]);
		x[1] = obj.FinnPunkt(grid[i-2][1]);
		x[2] = obj.FinnPunkt(grid[i][0]);
		x[3] = obj.FinnPunkt(grid[i][1]);

		len[1] = dist(grid[i-2][0], grid[i][0]);
		len[0] = dist(grid[i-2][1], grid[i][1]);
		
		obj.leggTilEdge(new Edge(x[3], x[1], -1, -1, -1, -1, -1, -1, len[0]));
		obj.leggTilEdge(new Edge(x[2], x[0], -1, -1, -1, -1, -1, -1, len[1]));
	}
	
	printf("Er kommet til 4\n");
	for(int j = 2; j < bredde; j++)
	{
		int x[4];
		double len[2];
		x[0] = obj.FinnPunkt(grid[0][j-2]);
		x[1] = obj.FinnPunkt(grid[1][j-2]);
		x[2] = obj.FinnPunkt(grid[0][j]);
		x[3] = obj.FinnPunkt(grid[1][j]);

		len[0] = dist(grid[0][j-2], grid[0][j]);
		len[1] = dist(grid[1][j-2], grid[1][j]);
		
		obj.leggTilEdge(new Edge(x[3], x[1], -1, -1, -1, -1, -1, -1, len[0]));
		obj.leggTilEdge(new Edge(x[2], x[0], -1, -1, -1, -1, -1, -1, len[1]));
	}

	SS.Endre(obj.np, obj.np);
	for(int i = 0; i < deleVerdi; i++)
	{
		SS(i, i).d[0][0] = 0;
		SS(i, i).d[0][1] = 0;
		SS(i, i).d[0][2] = 0;
		SS(i, i).d[1][0] = 0;
		SS(i, i).d[1][1] = 0;
		SS(i, i).d[1][2] = 0;
		SS(i, i).d[2][0] = 0;
		SS(i, i).d[2][1] = 0;
		SS(i, i).d[2][2] = 0;
	}
	for(int i = deleVerdi; i < obj.np; i++)
	{
		SS(i, i).d[0][0] = 1;
		SS(i, i).d[0][1] = 0;
		SS(i, i).d[0][2] = 0;
		SS(i, i).d[1][0] = 0;
		SS(i, i).d[1][1] = 1;
		SS(i, i).d[1][2] = 0;
		SS(i, i).d[2][0] = 0;
		SS(i, i).d[2][1] = 0;
		SS(i, i).d[2][2] = 1;
	}
}

void ParticleSystem::beregnKrefter()
{
	K.NullStill();
	L.NullStill();
	for(int i = 0; i < obj.np; i++)
	{
		g.d[0] = F(3*i) = 0;
		g.d[1] = F(3*i+1) = 0;
		g.d[2] = F(3*i+2) = 9.81*vekt;
	}

	for(int i = 0; i < obj.ne; i++)
	{
		int ni = 3*obj.e[i]->p[0], nj = 3*obj.e[i]->p[1];
		Vektor3D xi(p0(ni), p0(ni + 1), p0(ni + 2));
		Vektor3D xj(p0(nj), p0(nj + 1), p0(nj + 2));
		
		Vektor3D vi(v0(ni), v0(ni + 1), v0(ni + 2));
		Vektor3D vj(v0(nj), v0(nj + 1), v0(nj + 2));
		
		Vektor3D v(xi, xj);
		Vektor3D fv(vi, vj);
		double	norm = sqrt(v*v), 
				rest = obj.e[i]->rest, 
				ks = obj.e[i]->getKS(), 
				kd = obj.e[i]->getKD(), 
				C = norm-rest;

		if(norm == 0) norm = 1e-22;

		double oneovernorm = 1/norm;
		double oneovercubed = oneovernorm*oneovernorm*oneovernorm;

		Vektor3D dcdx[2] = { v*(-oneovernorm), v*oneovernorm };

		double c_dot = dcdx[1] * fv;
		Vektor3D f = dcdx[0]*(-ks*C - kd * c_dot);
		F(ni) += f.d[0];
		F(ni+1) += f.d[1];
		F(ni+2) += f.d[2];

		F(nj) -= f.d[0];
		F(nj+1) -= f.d[1];
		F(nj+2) -= f.d[2];

		Vektor3D d2[2][2];
		double temp = -(v.d[0]*v.d[0] + v.d[1]*v.d[1] + v.d[2]*v.d[2]) * oneovercubed + oneovernorm;

		d2[0][0] = Vektor3D(temp, temp, temp); 
		d2[0][1] = Vektor3D(-d2[0][0].d[0], -d2[0][0].d[1], -d2[0][0].d[2]); 
		d2[1][0] = d2[0][1];
		d2[1][1] = d2[0][0];
		int ind[2] = { ni/3, nj/3 };
		
		for(int i = 0; i < 2; i++)
		{
			for(int j = 0; j < 2; j++)
			{
				double dcdc[3][3] = { 
										dcdx[i].d[0] * dcdx[j].d[0], dcdx[i].d[0] * dcdx[j].d[1], dcdx[i].d[0] * dcdx[j].d[2],
										dcdx[i].d[1] * dcdx[j].d[0], dcdx[i].d[1] * dcdx[j].d[1], dcdx[i].d[1] * dcdx[j].d[2],
										dcdx[i].d[2] * dcdx[j].d[0], dcdx[i].d[2] * dcdx[j].d[1], dcdx[i].d[2] * dcdx[j].d[2]
				};

				Matrix3x3 dfdx, dfdv;
				//double dfdx[3][3];
				dfdx.d[0][0] = -ks*(dcdc[0][0] + d2[i][j].d[0] * C) - kd * (d2[i][j].d[0] * c_dot);
				dfdx.d[0][1] = -ks * dcdc[0][1];
				dfdx.d[0][2] = -ks * dcdc[0][2];
				dfdx.d[1][0] = -ks * dcdc[1][0];
				dfdx.d[1][1] = -ks*(dcdc[1][1] + d2[i][j].d[1] * C) - kd * (d2[i][j].d[1] * c_dot);
				dfdx.d[1][2] = -ks * dcdc[1][2];
				dfdx.d[2][0] = -ks * dcdc[2][0];
				dfdx.d[2][1] = -ks * dcdc[2][1];
				dfdx.d[2][2] = -ks*(dcdc[2][2] + d2[i][j].d[2] * C) - kd * (d2[i][j].d[2] * c_dot);


				// double dfdv[3][3];
				dfdv.d[0][0] = -kd * dcdc[0][0];
				dfdv.d[0][1] = -kd * dcdc[0][1];
				dfdv.d[0][2] = -kd * dcdc[0][2];
				dfdv.d[1][0] = -kd * dcdc[1][0];
				dfdv.d[1][1] = -kd * dcdc[1][1];
				dfdv.d[1][2] = -kd * dcdc[1][2];
				dfdv.d[2][0] = -kd * dcdc[2][0];
				dfdv.d[2][1] = -kd * dcdc[2][1];
				dfdv.d[2][2] = -kd * dcdc[2][2];

				K(ind[i], ind[j]) += dfdx;
				L(ind[i], ind[j]) += dfdv;
			}
		}
	}	
}

void sjekkKollisjon(Array &p, Array &v, Array &dv, double dt, int n, SMatrise &SS)
{
	static bool forste = true;
	static bool *kollidert = new bool[n];
	if(forste)
	{
		for(int i = 0; i < n; i++)
		{
			kollidert[i] = false;
		}
		forste = false;
	}
	// Har et plan i z = 8;
	for(int i = 0; i < 3*n; i++)
	{
		v(i) *= 0.999;
	}
	for(int i = 0; i < n; i++)
	{
		
		double z0 = p(3*i+2);
		double dz = (v(3*i+2) + dv(3*i+2)*dt)*dt;
		// z0 + dz*t = 3, har deaktivert kollisjonsdeteksjonen med false
		if(false && !Equals(dz, 0)&&!kollidert[i])
		{
			double t = (8.-z0)/dz;
			if(-0.00001 <= t && t <= 1.00001)
			{
				kollidert[i] = true;
				// Har kollisjon
				p(3*i+0) += (v(3*i+0) + dv(3*i+0)*dt)*dt*t;
				p(3*i+1) += (v(3*i+1) + dv(3*i+1)*dt)*dt*t;
				p(3*i+2) = z0 + t * dz;
				
				v(3*i+0) += dv(3*i+0)*dt*t;
				v(3*i+1) += dv(3*i+1)*dt*t;
				v(3*i+2) = 0;//dv(3*i+2)*dt*t*0;
				
				printf("%d har kollidert\n", i);
			}
			
			else
			{
				double friksjon = 0.99;
				p(3*i+0) += (v(3*i+0) + dv(3*i+0)*dt)*dt*friksjon;
				p(3*i+1) += (v(3*i+1) + dv(3*i+1)*dt)*dt*friksjon;
				p(3*i+2) = z0 + dz;

				v(3*i+0) += dv(3*i+0)*dt;
				v(3*i+1) += dv(3*i+1)*dt;
				v(3*i+2) += dv(3*i+2)*dt;
			}
		}
		else if(kollidert[i])
			{
				p(3*i+0) += (v(3*i+0) + dv(3*i+0)*dt)*dt;
				p(3*i+1) += (v(3*i+1) + dv(3*i+1)*dt)*dt;
				//p(3*i+2) = z0 + dz;

				v(3*i+0) += dv(3*i+0)*dt;
				v(3*i+1) += dv(3*i+1)*dt;
				v(3*i+2) += 0;
			}
		else
		{
			p(3*i+0) += (v(3*i+0) + dv(3*i+0)*dt)*dt;
			p(3*i+1) += (v(3*i+1) + dv(3*i+1)*dt)*dt;
			p(3*i+2) = z0 + dz;

			v(3*i+0) += dv(3*i+0)*dt;
			v(3*i+1) += dv(3*i+1)*dt;
			v(3*i+2) += dv(3*i+2)*dt;
			
		}
	}
	return;
	for(int i = 0; i < n; i++)
	{
		p(3*i+0) += (v(3*i+0) + dv(3*i+0)*dt)*dt;
		p(3*i+1) += (v(3*i+1) + dv(3*i+1)*dt)*dt;

		v(3*i+0) += dv(3*i+0)*dt;
		v(3*i+1) += dv(3*i+1)*dt;
		v(3*i+2) += dv(3*i+2)*dt;
	}

}


inline void formater(char sz[11], double verdi)
{
	if(Equals(verdi, 0))
	{
		sprintf_s(sz, 11, "+     .000");
		return;
	}
	char tegn;
	char temp1[7];
	char temp2[6];
	if(verdi < 0)
	{
		tegn = '-';
		verdi = -verdi;
	}
	else
	{
		tegn = '+';
	}
	int foran = 100000+(int)(verdi);
	verdi -= foran-100000;
	int bak = 1000+(int)(verdi * 1000+0.5);// + 1000 for  f 003 til  bli 003
	
	if(verdi > 100000)
	{
		strcpy_s(temp1, 7, "+++++++");
	}
	else
	{
		_itoa_s(foran, temp1, 7, 10);
	}

	_itoa_s(bak, temp2, 6, 10);
	for(int i = 1; i < 7; i++)
	{
		if(temp1[i] != '0')
		{
			break;
		}
		temp1[i] = ' ';
	}
	sprintf_s(sz, 11, "%c%s.%s", tegn, temp1+1, temp2+1);
}
void skriv(SMatrise &A)
{
	FILE *skriv;
	fopen_s(&skriv, "A_ut.txt", "w");
	static double *temp0 = new double[A.r*3];
	static double *temp1 = new double[A.r*3];
	static double *temp2 = new double[A.r*3];
	for(int i = 0; i < A.r; i++)
	{
		for(int j = 0; j < 3*A.r; j++)
		{
			temp0[j] = temp1[j] = temp2[j] = 0;
		}
		Node *p = A.row[i];
		while(p != NULL)
		{
			temp0[3*p->c+0] = p->data.d[0][0];
			temp0[3*p->c+1] = p->data.d[0][1];
			temp0[3*p->c+2] = p->data.d[0][2];

			temp1[3*p->c+0] = p->data.d[1][0];
			temp1[3*p->c+1] = p->data.d[1][1];
			temp1[3*p->c+2] = p->data.d[1][2];

			temp2[3*p->c+0] = p->data.d[2][0];
			temp2[3*p->c+1] = p->data.d[2][1];
			temp2[3*p->c+2] = p->data.d[2][2];

			p = p->neste;


		}
		char verdi1[10], verdi2[10], verdi3[20];
		for(int j = 0; j < A.r; j++)
		{
			formater(verdi1, temp0[3*j+0]);
			formater(verdi2, temp0[3*j+1]);
			formater(verdi3, temp0[3*j+2]);
			fprintf_s(skriv, "(%s, %s, %s)\t", verdi1, verdi2, verdi3);
		}
		fprintf_s(skriv, "\n");
		for(int j = 0; j < A.r; j++)
		{
			formater(verdi1, temp1[3*j+0]);
			formater(verdi2, temp1[3*j+1]);
			formater(verdi3, temp1[3*j+2]);
			fprintf_s(skriv, "(%s, %s, %s)\t", verdi1, verdi2, verdi3);
		}
		fprintf_s(skriv, "\n");
		for(int j = 0; j < A.r; j++)
		{
			formater(verdi1, temp2[3*j+0]);
			formater(verdi2, temp2[3*j+1]);
			formater(verdi3, temp2[3*j+2]);
			fprintf_s(skriv, "(%s, %s, %s)\t", verdi1, verdi2, verdi3);
		}
		fprintf_s(skriv, "\n");

	}
	fclose(skriv);
	printf("Ferdig  skrive filen\n");
	getchar();

}
void ParticleSystem::Jacobi(Array &dv, SMatrise &A, Array &ben, int n)
{

	// dv1(i) = 1/a(i, i) * (b(i) - SUM(j!=i, a(i, j)*dv0(j))
	static Array dv_t(3*n);
	static Array b(3*n);
	Array *dv0 = &dv, *dv1 = &dv_t;
	static Array test(3*n);
	
	filter(b, ben);
	
	double sum = 2000, forrigesum = 100000;;
	int step;
	static Matrix3x3 *inv = new Matrix3x3[n];
	for(int i = 0; i < n; i++)
	{
		inv[i] = A(i, i).inverse();
	}
	bool ikke_ferdig = true;
	for(step = 1; step < 10 && !Equals(sum, forrigesum); step++)
	{
		for(int i = 0; i < n; i++)
		{
			(*dv1)(3*i+0) = 0;
			(*dv1)(3*i+1) = 0;
			(*dv1)(3*i+2) = 0;
			
			Node *p = A.row[i];
			while(p != NULL)
			{
				if(p->c == i) 
				{
					p = p->neste;
					continue;
				}
				(*dv1)(3*i+0) += p->data.d[0][0] * dv0->data[3*p->c] + p->data.d[0][1] * dv0->data[3*p->c+1] + p->data.d[0][2] * dv0->data[3*p->c+2];
				(*dv1)(3*i+1) += p->data.d[1][0] * dv0->data[3*p->c] + p->data.d[1][1] * dv0->data[3*p->c+1] + p->data.d[1][2] * dv0->data[3*p->c+2];
				(*dv1)(3*i+2) += p->data.d[2][0] * dv0->data[3*p->c] + p->data.d[2][1] * dv0->data[3*p->c+1] + p->data.d[2][2] * dv0->data[3*p->c+2];
				p = p->neste;
			}
			
			dv1->data[3*i+0] = b(3*i+0) - dv1->data[3*i+0];
			dv1->data[3*i+1] = b(3*i+1) - dv1->data[3*i+1];
			dv1->data[3*i+2] = b(3*i+2) - dv1->data[3*i+2];
			
			double temp1 = inv[i].d[0][0] * dv1->data[3*i] + inv[i].d[0][1] * dv1->data[3*i+1] + inv[i].d[0][2] * dv1->data[3*i+2];
			double temp2 = inv[i].d[1][0] * dv1->data[3*i] + inv[i].d[1][1] * dv1->data[3*i+1] + inv[i].d[1][2] * dv1->data[3*i+2];
			double temp3 = inv[i].d[2][0] * dv1->data[3*i] + inv[i].d[2][1] * dv1->data[3*i+1] + inv[i].d[2][2] * dv1->data[3*i+2];

			double w = 1;
			if(w < 0) w = -w;
			if(w > 1) w = 1;

			(*dv1)(3*i+0) = (1-w)*dv0->data[3*i+0] + w * temp1;
			(*dv1)(3*i+1) = (1-w)*dv0->data[3*i+1] + w * temp2;
			(*dv1)(3*i+2) = (1-w)*dv0->data[3*i+2] + w * temp3;
			

			
		}
		filter(*dv0, *dv1);
	}
}
void ParticleSystem::beregnPosisjon()
{
	
	
	static long start = clock();
	
	int tid[15];
	for(int i = 0; i < 15; i++) tid[i] = 0;
	
	static int tall = 0;
	tall++;
#ifdef KDEBUG
	printf("Er kommet til beregnPosisjon, bilde %d\n", tall);
#endif
	double gammeldt = dt;
	bool ferdig = false;
	// Skal lse ligningssettet (I-h^2*M1*K)dv = hM1(F+K*v0)

	
	static bool forste = true;
	static int forsteTeller = true;
	
	
	
	//while(!ferdig)
	{
		teller++;
		A.NullStill(); 
		if(forste)
		{
			Matrix3x3 mass;
	mass.NullStill();
	mass.d[0][0] = mass.d[1][1] = mass.d[2][2] = vekt;
			I.NullStill();

			for(int i = 0; i < obj.np;i++) I(i, i) = mass;
			
			forste = false;
		}
		tid[0] = clock();
		
		
		// Konstruerer A-matrisen
		// A = I - dt*L-dt*dt*k;
		dtL.NullStill(); dtdtK.NullStill();
		LminusK.NullStill();
		
		mul(dtL, L, dt); mul(dtdtK, K, dt*dt);
		sum(LminusK, dtL, dtdtK);
		minus(A, I, LminusK);
		
		tid[1] = clock();
		
		// Initialiser dv-matrisen
		
		for(int i = 0; i < 3*obj.np; i++)
		{
			if(i < 3*deleVerdi) dv(i) = 0;
			else dv(i) = F(i);
		}
		

		
		// b = F + dt * dfdx * v0
		dtv0.NullStill();
		
		b.NullStill();
		FdtKv0.NullStill();
		dtKv0.NullStill();
		mul(dtv0, v0, dt);
		mul(dtKv0, K, dtv0);
		sum(FdtKv0, F, dtKv0);
		mul(b, FdtKv0, 1);
		tid[2] = clock();

		

		
		// Ls ligningssettet med CG metoden eller jacobimetoden
		
		Jacobi(dv, A, b, obj.np);
		//ferdig = CGSolver(dv, A, b, 1000);
		tid[3] = clock();
		
	}
	
	sjekkKollisjon(p0, v0, dv, dt, obj.np, SS);
		
	tid[4] = clock();
	tiden+=dt;
#ifdef KDEBUG 
	printf("Generere A: %d\nGenerere b: %d\nKjre CGSolve: %d\nIterere pos: %d\n", tid[1]-tid[0], tid[2]-tid[1], tid[3]-tid[2], tid[4]-tid[3]);

	printf("Det har gtt %lfs i programmet, programmet har brukt %lfs \n", tiden, (clock()-start)/1000.);
#endif
	
	// Passer p at hver kant ikke er utenfor 90%<-->110% intervallet, er ikke helt ndvendig med denne metoden
	for(int it = 0; it < 2; it++)
	for(int i = 0; i < obj.ne; i++)
	{
		Edge *e = obj.e[i];
		int xi = e->p[0];
		int xj = e->p[1];
		Point3D *p1 = obj.p[xi];
		Point3D *p2 = obj.p[xj];
		double len = dist(obj.p[xi], obj.p[xj]);
		double v[3];
		v[0] = p2->d[0]-p1->d[0];
		v[1] = p2->d[1]-p1->d[1];
		v[2] = p2->d[2]-p1->d[2];
		double vv = v[0]*v[0]+v[1]*v[1]+v[2]*v[2];
		v[0] /= vv;
		v[1] /= vv;
		v[2] /= vv;
		if(len < 0.9*e->rest)
		{
			double faktor = (len-e->rest)/3;
			if(xi >= deleVerdi && xj >= deleVerdi)
			{
				p0(3*xi+0) += faktor*v[0];
				p0(3*xi+1) += faktor*v[1];
				p0(3*xi+2) += faktor*v[2];
	
				p0(3*xj+0) -= faktor*v[0];
				p0(3*xj+1) -= faktor*v[1];
				p0(3*xj+2) -= faktor*v[2];

			}
			else if(xi >= deleVerdi)
			{
				p0(3*xi+0) += faktor*v[0]*2;
				p0(3*xi+1) += faktor*v[1]*2;
				p0(3*xi+2) += faktor*v[2]*2;
			}
			else if(xj >= deleVerdi)
			{
				p0(3*xj+0) += faktor*v[0]*2;
				p0(3*xj+1) += faktor*v[1]*2;
				p0(3*xj+2) += faktor*v[2]*2;
			}
		}
		else if(len > 1.1*e->rest)
		{
			double faktor = -(len-e->rest)/3;
			if(xi >= deleVerdi && xj >= deleVerdi)
			{
				p0(3*xi+0) += faktor*v[0];
				p0(3*xi+1) += faktor*v[1];
				p0(3*xi+2) += faktor*v[2];
	
				p0(3*xj+0) -= faktor*v[0];
				p0(3*xj+1) -= faktor*v[1];
				p0(3*xj+2) -= faktor*v[2];

			}
			else if(xi >= deleVerdi)
			{
				p0(3*xi+0) += faktor*v[0]*2;
				p0(3*xi+1) += faktor*v[1]*2;
				p0(3*xi+2) += faktor*v[2]*2;
			}
			else if(xj >= deleVerdi)
			{
				p0(3*xj+0) += faktor*v[0]*2;
				p0(3*xj+1) += faktor*v[1]*2;
				p0(3*xj+2) += faktor*v[2]*2;
			}
		}
	}
	
}


void ParticleSystem::lagP(SMatrise &P, SMatrise &P1, SMatrise &A)
{
	for(int i = 0; i < obj.np; i++)
	{
		P(i, i) = A(i, i).inverse();
		P1(i, i) = A(i, i);
	}
}

// Filter-metoden for  hindre unsket bevegelse av partiklene
// Testene angende restriksjoner er gjort ved  angi et visst antall
// partikler som er helt lst under simulering, deleVerdi vil si
// hvor mange partikler som er lst(ganget med 3 pga representasjon av matrisene)
void ParticleSystem::filtrer(Array &a)
{
	for(int i = 0; i < 3*deleVerdi; i++) a(i) = 0;
}
void ParticleSystem::filter(Array &res, Array &a)
{
	mul(res, SS, a);	
}
void ParticleSystem::initHjelp()
{
	P.Endre(obj.np, obj.np); 
	P1.Endre(obj.np, obj.np);
	PbFil.Endre(3*obj.np);
	Adv.Endre(3*obj.np);
	bFilTPb.Endre(3*obj.np);
	r.Endre(3*obj.np);
	c.Endre(3*obj.np);
	s.Endre(3*obj.np);
	q.Endre(3*obj.np);
	
	
	
	P1r.Endre(3*obj.np);
	bAdv.Endre(3*obj.np);
	bFil.Endre(3*obj.np);

	// SMatrise dtL, dtdtK, LM, KM, LminusK;
	dtL.Endre(obj.np, obj.np);
	dtdtK.Endre(obj.np, obj.np);
	LM.Endre(obj.np, obj.np);
	KM.Endre(obj.np, obj.np);
	LminusK.Endre(obj.np, obj.np);
	
	

	dtK.Endre(obj.np, obj.np);
	b.Endre(3*obj.np);
	dtv0.Endre(3*obj.np);
	dtKv0.Endre(3*obj.np);
	FdtKv0.Endre(3*obj.np);
	n.Endre(3*obj.np);

}
bool ParticleSystem::CGSolver(Array &dv, SMatrise &A, Array &b, int antall)
{
	
	int tid[1000];
	tid[0] = clock();
	int indeks = 0;
	
	lagP(P, P1, A);
	
	filter(bFil, b);
	
	mul(PbFil, P, bFil);
	double sigmaNull;
	mul(sigmaNull, bFil, PbFil);

	
	// r = b-A*dv
	mul(Adv, A, dv); // Adv = prod(A, dv);
	minus(bAdv, b, Adv); // bAdv = b - Adv;
	
	filter(r, bAdv); // r = filter(bAdv);
	


	// c = filter(P1*r)
	mul(P1r, P1, r); // P1r = prod(P1, r);
	filter(c, P1r);

	
	// sigmaNy = rT*c
	double sigmaNy;
	mul(sigmaNy, r, c); // double sigmaNy = (prod(trans(r), c))(0, 0);
	
	double liten = 0.0000001;//1e-22;//0.00001;//

	tid[1] = clock();
	int maxIt = 30;//2*(int)sqrt((double)obj.np)*3 + 3;
	
	while(sigmaNy > liten * sigmaNull && indeks < antall && indeks < maxIt) 
	{
		if(sigmaNy <= liten * sigmaNull) break;
		indeks++;

		
		// q = filter(A*c)
		mul(b, A, c);
		filter(q, b);

		// alfa = sigmaNy/(cT*q)
		double alfa;
		mul(alfa, c, q); 
		alfa = sigmaNy / alfa;

		// dv = dv + alfa*c
		for(int i = 0; i < dv.l; i++) // dv += alfa * c;
		{
			dv(i) += alfa * c(i);
		}


		// r = r - alfa*q
		for(int i = 0; i < r.l; i++) // r -= alfa * q;
		{
			
			r(i) -= alfa * q(i);
		}
		

		// s = P1*r
		mul(s, P1, r);

		// sigmaOld = sigmaNy
		double sigmaOld = sigmaNy;

		
		// sigmaNy = rT*s
		mul(sigmaNy, r, s); // sigmaNy = (prod(trans(r), s))(0, 0);
		
		// c = filter(s + sigmaNy/sigmaOld * c)
		mul(c, c, (sigmaNy/sigmaOld));
		sum(b, s, c); // = s + (sigmaNy/sigmaOld)*c;
		filter(c, b);
		
	}
	#ifdef KDEBUG
	printf("Det ble kjrt %d iterasjoner\n", indeks);
	#endif
	
	return (indeks < maxIt) && (indeks > minIt);
}

void ParticleSystem::init()
{

	// Initialiserer en test av systemet
	LagLaken();
	
	initHjelp();
	dv.Endre(3*obj.np);
	K.Endre(obj.np, obj.np);
	L.Endre(obj.np, obj.np);
	M1.Endre(3*obj.np);
	//S.Endre(obj.np, obj.np);
	//p0 = Array(3*obj.np);
	p0.Endre(3*obj.np);

	F.Endre(3*obj.np);
	FExt.Endre(3*obj.np);
	v0.Endre(3*obj.np);
	v1.Endre(3*obj.np);
	A.Endre(obj.np, obj.np);
	I.Endre(obj.np, obj.np);
	//
	for(int i = 0; i < 3*obj.np; i++)
	{
		p0(i) = obj.p[i/3]->d[i%3];
		v0(i) = 0;
		v1(i) = 0;
		M1(i) = 1/vekt;
		FExt(i) = 0;
		F(i) = 0;
		
	}

}

