#include "ParticleSystem.h"
#include <time.h>
#include "jpeg.h"
#include <wchar.h>
#include <stdio.h>
#include <GL/glut.h>
#include "tga.h"
#define ONE_SECOND 	 1	// one second
#define MAX_TEXTURES 	 1  	// max textures displayed

double ***pos;
int bildeNummer = 0;
bool captureFrame = false;
double bilde = 0;
int nSek = 35;
int indeks = 0;
ParticleSystem p;
bool itererer = false;
int w, h;
double *p_init;
GLfloat position[] = { 5, 5, 0, 1};

/* creates a enum type for mouse buttons */
enum {
    BUTTON_LEFT = 0,
    BUTTON_RIGHT,
    BUTTON_LEFT_TRANSLATE,
};

/* set global variables */
int mButton = -1;
int mOldY, mOldX;
float dt;
/* vectors that makes the rotation and translation of the cube */
float eye[3] = {0.0f, 0.0f, 7.0f};
float rot[3] = {45.0f, 45.0f, 0.0f};

const int ESC = 27;

int wireframe = 0;

/* windows size and position constants */
const int GL_WIN_WIDTH = 640;
const int GL_WIN_HEIGHT = 480;
const int GL_WIN_INITIAL_X = 0;
const int GL_WIN_INITIAL_Y = 0;

/* array to hold texture handles */
GLuint g_TexturesArray[MAX_TEXTURES];

void drawFrameRate(char *str, void *font, GLclampf r, GLclampf g, GLclampf b,
              GLfloat x, GLfloat y);

GLuint teksturen;

void hentTekstur()
{
	
	imageRGB bilde = read_JPEG_file("teksturer\\img062.jpg");
	glGenTextures(1, &teksturen);
	glBindTexture(GL_TEXTURE_2D, teksturen);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, bilde.width, bilde.height, 0, GL_RGB, GL_UNSIGNED_BYTE, bilde.data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);// Linear Filtering
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);// Linear Filtering
}

//------------------------------------------------------------------------
// Calculates the current frame rate
//------------------------------------------------------------------------

void CalculateFrameRate()
{


    static float framesPerSecond    = 0.0f;        // This will store our fps
    static long lastTime            = 0;           // This will hold the time from the last frame
    static char strFrameRate[50]    = {0};         // We will store the string here for the window title
    
    // struct for the time value
    struct timeval currentTime;
	currentTime.tv_sec  = 0;
	currentTime.tv_usec = 0; 

    // gets the microseconds passed since app started
    //gettimeofday(&currentTime, NULL);	    
	currentTime.tv_sec = (long)(clock())/1000;

    // Increase the frame counter
    ++framesPerSecond;

    if( currentTime.tv_sec - lastTime >= ONE_SECOND )
    {
        lastTime = currentTime.tv_sec;

        // Copy the frames per second into a string to display in the window
        sprintf_s(strFrameRate, "Current Frames Per Second: %d", int(framesPerSecond));

        // Reset the frames per second
        framesPerSecond = 0;

    }
	static long forrigeTid = clock();
	long denne = clock();
	dt = (denne - forrigeTid)/1000.;
	// printf("ForrigeTid = %d\n", forrigeTid);
	forrigeTid = denne;
	
	

    // draw frame rate on screen
    drawFrameRate(strFrameRate, GLUT_BITMAP_HELVETICA_10, 1.0f, 1.0f, 1.0f, 0.05, 0.95 );
	
}

//------------------------------------------------------------------------
// Draws the current frame rate on screen
//------------------------------------------------------------------------

void drawFrameRate(char *str, void *font, GLclampf r, GLclampf g, GLclampf b,
              GLfloat x, GLfloat y) {
  /* font: font to use, e.g., GLUT_BITMAP_HELVETICA_10
     r, g, b: text colour
     x, y: text position in window: range [0,0] (bottom left of window)
           to [1,1] (top right of window). */

  char *ch;
  GLint matrixMode;
  GLboolean lightingOn;

 lightingOn= glIsEnabled(GL_LIGHTING);        /* lighting on? */
 glDisable(GL_LIGHTING);

 glGetIntegerv(GL_MATRIX_MODE, &matrixMode);  /* matrix mode? */

 glMatrixMode(GL_PROJECTION);
 glPushMatrix();
   glLoadIdentity();
   gluOrtho2D(0.0, 1.0, 0.0, 1.0);
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
     glLoadIdentity();
     glPushAttrib(GL_COLOR_BUFFER_BIT);       /* save current colour */
       glColor3f(r, g, b);
       glRasterPos3f(x, y, 0.0);
       for(ch= str; *ch; ch++) {
          glutBitmapCharacter(font, (int)*ch);
       }
     glPopAttrib();
   glPopMatrix();
   glMatrixMode(GL_PROJECTION);
 glPopMatrix();
 glMatrixMode(matrixMode);
 glEnable(GL_LIGHTING);
}

void drawChar(char *sz, int linje)
{
	GLint matrixMode;
	GLboolean lightingOn;

	lightingOn= glIsEnabled(GL_LIGHTING);        /* lighting on? */
	if(lightingOn) glDisable(GL_LIGHTING);

	glGetIntegerv(GL_MATRIX_MODE, &matrixMode);  /* matrix mode? */

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
		glLoadIdentity();
		gluOrtho2D(0.0, 1.0, 0.0, 1.0);
	char *ch;
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
		glLoadIdentity();
		glPushAttrib(GL_COLOR_BUFFER_BIT);       /* save current colour */
			glColor3f(1, 1, 1);
			glRasterPos3f(0.05, 0.95-0.03*linje, 0.0);
			for(ch= sz; *ch; ch++) {
			glutBitmapCharacter(GLUT_BITMAP_9_BY_15, (int)*ch);
			}
			
		glPopAttrib();
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(matrixMode);
	if(lightingOn) glEnable(GL_LIGHTING);
}
//------------------------------------------------------------------------
// Window resize function
//------------------------------------------------------------------------
void glutResize(int width, int height)
{
	w = width; h = height;
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
      /* modify this line to change perspective values */
	gluPerspective(45.0, (float)width/(float)height, 0.0001, 300.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

//------------------------------------------------------------------------
// Function that handles keyboard inputs
//------------------------------------------------------------------------
void glutKeyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
		case '+':
			indeks++;
			break;
		case '-':
			indeks--;
			break;
		case ESC:
			//exit(0);
		case 'P':
		case 'p':
			itererer = !itererer;
			break;
		case 'r':
		case 'R':
			itererer = false;
			for(int i = 0; i < 3*p.obj.np; i++)
			{
				p.p0(i) = p_init[i];
				p.v0(i) = 0;
			}
			p.teller = 0;
			p.dt = 0.01f;
			p.tiden = 0;
			break;
		case 'a':
		case 'A':
			
			Edge::STRETCH_KS = Edge::STRETCH_KS * 1.1;
			break;
		case 's':
		case 'S':
			Edge::STRETCH_KS = Edge::STRETCH_KS / 1.1;
			break;
		
		case 'd':
		case 'D':
			Edge::STRETCH_KD = Edge::STRETCH_KD * 1.1;
			break;
		case 'f':
		case 'F':
			Edge::STRETCH_KD = Edge::STRETCH_KD / 1.1;
			break;
		
		case 'g':
		case 'G':
			Edge::BEND_KS = Edge::BEND_KS * 1.1;
			break;
		case 'h':
		case 'H':
			Edge::BEND_KS = Edge::BEND_KS / 1.1;
			break;

		case 'j':
		case 'J':
			Edge::BEND_KD = Edge::BEND_KD * 1.1;
			break;
		case 'k':
		case 'K':
			Edge::BEND_KD = Edge::BEND_KD / 1.1;
			break;


		case 'v':
		case 'V':
			Edge::SHEAR_KS = Edge::SHEAR_KS * 1.1;
			break;
		case 'b':
		case 'B':
			Edge::SHEAR_KS = Edge::SHEAR_KS / 1.1;
			break;

		case 'n':
		case 'N':
			Edge::SHEAR_KD = Edge::SHEAR_KD * 1.1;
			break;
		case 'm':
		case 'M':
			Edge::SHEAR_KD = Edge::SHEAR_KD / 1.1;
			break;
		case 'W':
		case 'w':
		    wireframe = !wireframe;
			break;
		case 'z':
		case 'Z':
			p.vekt *= 1.1;
			break;
		case 'x':
		case 'X':
			p.vekt /= 1.1;
			break;
		case 'c':
		case 'C':
			captureFrame = true;
			for(int i = 0; i < 3*p.obj.np; i++)
			{
				p.p0(i) = p_init[i];
				p.v0(i) = 0;
			}
			p.teller = 0;
			p.dt = 0.01f;
			p.tiden = 0;
			bildeNummer = 0;
			itererer = true;
			break;
		
	}
}

//------------------------------------------------------------------------
// If rotation angle is greater of 360 or lesser than -360,
// resets it back to zero.
//------------------------------------------------------------------------
void clamp(float *v)
{
    int i;

    for (i = 0; i < 3; i ++)
        if (v[i] > 360 || v[i] < -360)
            v[i] = 0;
}

//------------------------------------------------------------------------
// Moves the screen based on mouse pressed button
//------------------------------------------------------------------------
void glutMotion(int x, int y)
{
    if (mButton == BUTTON_LEFT)
    {
        /* rotates screen */
        rot[0] -= (mOldY - y);
        rot[1] -= (mOldX - x);
        clamp (rot);
    }
	else if (mButton == BUTTON_RIGHT)
    {
        /*
           translate the screen, z axis
           gives the idea of zooming in and out 
        */        
        eye[2] -= (mOldY - y) * 0.05f; // here I multiply by a 0.2 factor to 
                                      // slow down the zoom
        clamp (rot);
    } 
    else if (mButton == BUTTON_LEFT_TRANSLATE)
    {
        eye[0] += (mOldX - x) * 0.01f;
        eye[1] -= (mOldY - y) * 0.01f;
        clamp (rot);
    }

    mOldX = x;
    mOldY = y;
}

//------------------------------------------------------------------------
// Function that handles mouse input
//------------------------------------------------------------------------
void glutMouse(int button, int state, int x, int y)
{
    if(state == GLUT_DOWN)
    {
        mOldX = x;
        mOldY = y;
        switch(button)
        {
            case GLUT_LEFT_BUTTON:
                if (glutGetModifiers() == GLUT_ACTIVE_CTRL)
                {
                   mButton = BUTTON_LEFT_TRANSLATE;
                   break;
                } else
                {
                   mButton = BUTTON_LEFT;
                   break;
                }
            case GLUT_RIGHT_BUTTON:
                mButton = BUTTON_RIGHT;
                break;
        }
    } else if (state == GLUT_UP)
      mButton = -1;
}

//------------------------------------------------------------------------
// The glut's menu callback function. Called every time an option is selected
//------------------------------------------------------------------------
void glutMenu(int value)
{
	switch (value)
	{
		case 1:
			glutFullScreen();
			return;

		case 2:
			break;
			//exit(0);
	}
}

//------------------------------------------------------------------------
// Function that handles special keyboards input (SHIFT, CTRL, ALT)
//------------------------------------------------------------------------
void glutSpecial(int value, int x, int y)
{
    switch (value)
    {
        case GLUT_KEY_F1:
                glutFullScreen();
                return;
    }
}

void glutDisplay(void)
{
	static long forrige = clock();
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, teksturen);
	glLoadIdentity();
	
    /* translate camera to the coordinates provided by eye array */
    glTranslatef (-eye[0]-3, -eye[1]+2, -eye[2]);

	
    /* rotates the screen by the angles provided by rot array */
    glRotatef(rot[0], 1.0f, 0.0f, 0.0f);
    glRotatef(rot[1], 0.0f, 1.0f, 0.0f);
    glRotatef(rot[2], 0.0f, 0.0f, 1.0f);

	glLightfv(GL_LIGHT0, GL_POSITION, position);

	glPointSize(5);
	glBegin(GL_LINES);
	glVertex4fv(position);
	glVertex4f(0, 0, 0, 1);
	glEnd();
	
	static bool forste = true;
	static Array texCoord(2*p.obj.np);
	if(forste)
	{
		for(int i = 0; i < p.obj.np; i++)
		{
			int ind = 3*i;
			int tind = 2*i;
			// x gr fra 0 til 5.5, samme med y
			texCoord(tind) = (5.5-p.p0(ind))/5.5;
			texCoord(tind+1) = (5.5-p.p0(ind+1))/5.5;
		}
		forste = false;
	}

	if(itererer)
	{
			
		p.beregnKrefter();
		p.beregnPosisjon();
		static int bilde = 0;
	}
	
	
	
	for(int i = 0; i < 3*p.obj.np; i++) p.n(i) = 0;
	for(int i = 0; i < p.obj.nt; i++)
	{
		int ind0 = 3*p.obj.t[i]->p[0];
		int ind1 = 3*p.obj.t[i]->p[1];
		int ind2 = 3*p.obj.t[i]->p[2];
		Point3D p0(p.p0(ind0),p.p0(ind0+1),p.p0(ind0+2));
		Point3D p1(p.p0(ind1),p.p0(ind1+1),p.p0(ind1+2));
		Point3D p2(p.p0(ind2),p.p0(ind2+1),p.p0(ind2+2));

		Vektor3D v0(p0, p1);
		Vektor3D v1(p0, p2);

		Vektor3D n = v0.Cross(v1);
		
		p.n(ind0) += n.d[0];
		p.n(ind0+1) += n.d[1];
		p.n(ind0+2) += n.d[2];

		p.n(ind1) += n.d[0];
		p.n(ind1+1) += n.d[1];
		p.n(ind1+2) += n.d[2];

		p.n(ind2) += n.d[0];
		p.n(ind2+1) += n.d[1];
		p.n(ind2+2) += n.d[2];
	}

	for(int i = 0; i < p.obj.np; i++)
	{
		int ind = 3*i;
		double len = sqrt(p.n(ind)*p.n(ind)+p.n(ind+1)*p.n(ind+1)+p.n(ind+2)*p.n(ind+2));
		p.n(ind) /= len;
		p.n(ind+1) /= len;
		p.n(ind+2) /= len;
	}
	glBegin(GL_TRIANGLES);
	for(int i = 0; i < p.obj.nt; i++)
	{
		int ind0 = 3*p.obj.t[i]->p[0];
		int ind1 = 3*p.obj.t[i]->p[1];
		int ind2 = 3*p.obj.t[i]->p[2];
		Point3D p0(p.p0(ind0),p.p0(ind0+1),p.p0(ind0+2));
		Point3D p1(p.p0(ind1),p.p0(ind1+1),p.p0(ind1+2));
		Point3D p2(p.p0(ind2),p.p0(ind2+1),p.p0(ind2+2));

		Vektor3D n0(p.n(ind0), p.n(ind0+1), p.n(ind0+2));
		
		glTexCoord2f(texCoord(2*ind0/3), texCoord(2*ind0/3+1)); glNormal3f(p.n(ind0), p.n(ind0+1), p.n(ind0+2)); glVertex3f(p0.d[0], p0.d[1], p0.d[2]);
		glTexCoord2f(texCoord(2*ind1/3), texCoord(2*ind1/3+1)); glNormal3f(p.n(ind1), p.n(ind1+1), p.n(ind1+2)); glVertex3f(p1.d[0], p1.d[1], p1.d[2]);
		glTexCoord2f(texCoord(2*ind2/3), texCoord(2*ind2/3+1)); glNormal3f(p.n(ind2), p.n(ind2+1), p.n(ind2+2)); glVertex3f(p2.d[0], p2.d[1], p2.d[2]);
	}
	glEnd();
}

void InitializeOGL()
{
	p.init();
	p_init = new double[3*p.obj.np];
	for(int i = 0; i < 3*p.obj.np; i++)
	{
		p_init[i] = p.p0(i);
	}
    glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
    glShadeModel(GL_SMOOTH);
    glEnable(GL_DEPTH_TEST);

	// enable texture and binds a texture to the first element of the array
    glEnable(GL_TEXTURE_2D);	
    CreateTexture(g_TexturesArray,"logo.tga",0);

	GLfloat pos[3] = { 2, 2, 3};
	GLfloat LightAmb[] = {0.7f, 0.7f, 0.7f, 1.0f};// Ambient Light
	GLfloat LightDif[] = {1.0f, 1.0f, 1.0f, 1.0f};// Diffuse Light
	GLfloat LightPos[] = {4.0f, 4.0f, 6.0f, 1.0f};
	glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmb);// Set The Ambient Lighting For Light0
	glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDif);// Set The Diffuse Lighting For Light0
	glLightfv(GL_LIGHT0, GL_POSITION, LightPos);// Set The Position For Light0

	glEnable(GL_LIGHT0);// Enable Light 0
	glEnable(GL_LIGHTING);// Enable Lighting
}
void glutDisplayInfo()
{
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0, -2, -5);

	
	
	CalculateFrameRate();

	char sz[5][1000];
	sprintf_s(sz[0], 1000, "dt         = %1.4lf", p.dt);
	sprintf_s(sz[4], 1000, "w          = %1.4lf		(Z/X)", p.vekt);
	sprintf_s(sz[1], 1000, "STRETCH KS = %5.2lf     STRETCH_KD = %0.7lf   (A/S D/F)", Edge::STRETCH_KS, Edge::STRETCH_KD);
	sprintf_s(sz[2], 1000, "BEND_KS    = %5.2lf     BEND_KD    = %0.7lf   (G/H J/K)", Edge::BEND_KS, Edge::BEND_KD);
	sprintf_s(sz[3], 1000, "SHEAR_KS   = %5.2lf     SHEAR_KD   = %0.7lf   (V/B N/M)", Edge::SHEAR_KS, Edge::SHEAR_KD);
	drawChar(sz[0], 2);
	drawChar(sz[1], 3);
	drawChar(sz[2], 4);
	drawChar(sz[3], 5);
	drawChar(sz[4], 1);

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}
void displayAll()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glutDisplay();
	
	if(!captureFrame)
	{
		glutDisplayInfo();
	}
	else
	{
		glFlush();
		static GLubyte *bildet = new GLubyte[1024*1024*3];
		glReadPixels(0, 0, 1024, 1024, GL_RGB, GL_UNSIGNED_BYTE, bildet);
		char filnavn[1000];
		sprintf_s(filnavn, 1000, "frame_%d.jpeg", bildeNummer++);
		
		imageRGB ut;
		ut.width = 1024;
		ut.height = 1024;
		ut.data = bildet;
		write_JPEG_file(filnavn, 100, ut);
		
	}
	glutSwapBuffers();

	
}
void disp3()
{
	static long start = clock();
	static int n = 0;
	n++;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glTranslatef(0, 0, -1);
	// CalculateFrameRate();
	long denne = clock();
	long diff = denne - start;
	if(diff != 0)
	{
		printf("Det er %3.2lf fps etter \n", 1000.*n/(double)diff);
	}

	glutSwapBuffers();
}
//------------------------------------------------------------------------
//   It's the main application function. Note the clean code you can
//   obtain using he GLUT library. No calls to dark windows API
//   functions with many obscure parameters list. =)
//------------------------------------------------------------------------
int main(int argc, char** argv)
{
    /*
        Glut's initialization code. Set window's size and type of display.
        Window size is put half the 800x600 resolution as defined by above
	constants. The windows is positioned at the top leftmost area of
	the screen.
    */
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGBA | GLUT_MULTISAMPLE );
    glutInitWindowPosition( GL_WIN_INITIAL_X, GL_WIN_INITIAL_Y );
    glutInitWindowSize( 1024, 1024);
    glutInit( &argc, argv );

    glutCreateWindow("Partikkelsystem CPU");

    /*
       The function below are called when the respective event
       is triggered. Very simple, isn't it?
    */
    glutReshapeFunc(glutResize);       // called every time  the screen is resized
    glutDisplayFunc(displayAll);      // called when window needs to be redisplayed
    glutIdleFunc(displayAll);         // called whenever the application is idle
    glutKeyboardFunc(glutKeyboard);    // called when the application receives a input from the keyboard
    glutMouseFunc(glutMouse);          // called when the application receives a input from the mouse
    glutMotionFunc(glutMotion);        // called when the mouse moves over the screen with one of this button pressed
    glutSpecialFunc(glutSpecial);      // called when a special key is pressed like SHIFT

    /*
        Do any lighting, material, alpha, etc initialization or
        configuration here.
    */
    InitializeOGL();

    /*
        Creates a menu attached to the mouses middle button
        the menu here consists in two options, one to toggle
        fullscreen mode and another for exiting the application.
    */
	glutCreateMenu(glutMenu);
	glutAddMenuEntry("Full Screen", 1);
	glutAddMenuEntry("Exit", 2);
	glutAttachMenu(GLUT_MIDDLE_BUTTON);

    /*
       Application's main loop. All the above functions
	 are called whe the respective events are triggered
    */
	hentTekstur();
	glutMainLoop();

	return 0;
}

