#include "CGStruct.h"
int CGStruct::kall_loadVertex = 0;
int CGStruct::kall_loadFragment = 0;

CGStruct::CGStruct(char *verProg, char *fraProg,							// Hvilke filer skal lastes inn
		 char **verParNavn, int verAntPar,	// Parameterliste for binding for vertex-programmet
		 char **fraParNavn, int fraAntPar,	// Parameterliste for binding for fragment-programmet
		 char *vertexMain, char *fragmentMain	// Hva heter main-funksjonene
		 )
{
	/*char verProg[1000], fraProg[1000], vertexMain[1000], fragmentMain[1000];
	sprintf_s(verProg, 1000, "library.cg");
	sprintf_s(fraProg, 1000, "library.cg");
	sprintf_s(vertexMain, 1000, "mainVertexNull");
	sprintf_s(fragmentMain, 1000, "mainNull");*/

	printf("Skal lage CGStruct(%s(%s), %s(%s))\n", (verProg == NULL ? "" : verProg), (vertexMain == NULL ? "" : vertexMain), (fraProg == NULL ? "" : fraProg), (fragmentMain == NULL ? "" : fragmentMain));
	this->verPar = new CGparameter[verAntPar]; this->verAntPar = verAntPar;
	this->fraPar = new CGparameter[fraAntPar]; this->fraAntPar = fraAntPar;

	// Setup Cg
	cgContext = cgCreateContext();										// Create A New Context For Our Cg Program(s)

	// Validate Our Context Generation Was Successful
	if (cgContext == NULL)
	{
		Error("Failed To Create Cg Context");
		return;													// We Cannot Continue
	}

	cgVertexProfile = cgGLGetLatestProfile(CG_GL_VERTEX);				// Get The Latest GL Vertex Profile
	cgFragmentProfile = cgGLGetLatestProfile(CG_GL_FRAGMENT);				// Get The Latest GL Vertex Profile

	// Validate Our Profile Determination Was Successful
	if (cgVertexProfile == CG_PROFILE_UNKNOWN)
	{
		Error("Invalid profile type");
		return ;													// We Cannot Continue
	}
	if (cgFragmentProfile == CG_PROFILE_UNKNOWN)
	{
		Error("Invalid profile type");
		return ;													// We Cannot Continue
	}
	cgGLSetOptimalOptions(cgVertexProfile);								// Set The Current Profile
	cgGLSetOptimalOptions(cgFragmentProfile);
	// Load And Compile The Vertex Shader From File
	cgVertexProgram = (verProg == NULL ? NULL : cgCreateProgramFromFile(cgContext, CG_SOURCE, verProg, CG_PROFILE_VP40, vertexMain, 0));
	if(cgVertexProgram == NULL && verProg != NULL)
	{
		char filnavn[1000];
		sprintf_s(filnavn, 1000, "%s/%s", "c:/cgprogram", verProg);
		cgVertexProgram = cgCreateProgramFromFile(cgContext, CG_SOURCE, filnavn, CG_PROFILE_VP40, vertexMain, 0);
	}
	cgFragmentProgram = (fraProg == NULL ? NULL : cgCreateProgramFromFile(cgContext, CG_SOURCE, fraProg, CG_PROFILE_FP40, fragmentMain, 0));
	if(cgFragmentProgram == NULL && fraProg != NULL)
	{
		char filnavn[1000];
		sprintf_s(filnavn, 1000, "%s/%s", "c:/cgprogram", verProg);
		cgFragmentProgram = cgCreateProgramFromFile(cgContext, CG_SOURCE, filnavn, CG_PROFILE_FP40, fragmentMain, 0);
	}


	// Validate Success
	if (cgVertexProgram == NULL && verProg != NULL)
	{
		Error("Klarte ikke  laste vertexprogrammet");
		return ;													// We Cannot Continue
	}

	// Load The Program
	if(cgVertexProgram != NULL) cgGLLoadProgram(cgVertexProgram);

	if(cgFragmentProgram == NULL && fraProg != NULL)
	{
		Error("Klarte ikke  laste fragmentprogrammet");
		return ;													// We Cannot Continue
	}

	if(cgFragmentProgram != NULL) cgGLLoadProgram(cgFragmentProgram);

	// Get Handles To Each Of Our Parameters So That
	// We Can Change Them At Will Within Our Code
	for(int i = 0; i < verAntPar; i++)
	{
		verPar[i] = cgGetNamedParameter(cgVertexProgram, verParNavn[i]);
		if(verPar[i] == NULL)
		{
			printf("Klarte ikke  binde parameteren <%s>\n", verParNavn[i]);
		}
	}
	for(int i = 0; i < fraAntPar; i++)
	{
		fraPar[i] = cgGetNamedParameter(cgFragmentProgram, fraParNavn[i]);
		if(fraPar[i] == NULL)
		{
			printf("Klarte ikke  binde parameteren <%s>\n", fraParNavn[i]);
		}
	}
	return ;
}
void CGStruct::Error(char *sz)
{
	CGerror err = cgGetError();
	printf("\n\n%s\n%s\n\n\n", sz, cgGetErrorString(err)); 
	while(true);
}
