#include <stdio.h>
#include <gl/glew.h>
#include <gl/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>
#include "Texture.h"
#include "CGStruct.h"
#include "jpeg.h"
#include <time.h>
#include "ParticleSystemGPU.h"
int ii = 50;
// Variable for bevegelse
enum { X, Y, Z };
float rot[3];
float steg = 0.5f;
GLfloat zpos = 0;
int forrigeX, forrigeY;
bool venstre = false, hoyre = false, midt = false;
GLfloat lightPos[3] = { 1, 1, 1 };

// Partikkelsystemet
ParticleSystemGPU *ps;

int ww, hh;
static bool kjorer = false;

void fps()
{
	 static float framesPerSecond    = 0.0f;        // This will store our fps
    static long lastTime            = 0;           // This will hold the time from the last frame
    static char strFrameRate[50]    = {0};         // We will store the string here for the window title
    
    // struct for the time value
    struct timeval currentTime;
	currentTime.tv_sec  = 0;
	currentTime.tv_usec = 0; 

    // gets the microseconds passed since app started
    //gettimeofday(&currentTime, NULL);	    
	currentTime.tv_sec = (long)(clock())/1000;

    // Increase the frame counter
    ++framesPerSecond;

    if( currentTime.tv_sec - lastTime >= 1 )
    {
        lastTime = currentTime.tv_sec;

        // Copy the frames per second into a string to display in the window
        printf("Current Frames Per Second: %d\n", int(framesPerSecond));

        // Reset the frames per second
        framesPerSecond = 0;

    }
}
void display()
{

	fps();
	FILE *stream;
	fopen_s(&stream, "resultat.txt", "w");
	
	if(kjorer) 
	{
		ps->iterer();
#ifdef _DEBUG
		kjorer = false;
#endif
	}
	
	
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();
	
	static double arot[3];
	
	arot[0] += rot[0]; arot[1] += rot[1]; arot[2] += rot[2];
	glTranslatef(0, 0, zpos);
	glRotatef(arot[0], 1, 0, 0);
	glRotatef(arot[1], 0, 1, 0);
	glRotatef(arot[2], 0, 0, 2);
	rot[0] = rot[1] = rot[2] = 0;
	
	
	
	ps->tegn();
	
	glutSwapBuffers();

	CheckError("Etter endt display");	
}

void idle()
{

	glutPostRedisplay();
}
void reshape(int w, int h)
{
	glViewport(0, 0, w, h);
	ww = w;
	hh = h;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	gluPerspective(60., (GLfloat)w/(GLfloat)h, 1., 200.);
	
	glMatrixMode(GL_MODELVIEW);
	
}

void keyboard(unsigned char key, int pos, int p2)
{
	switch((int)key)
	{
	case 27:
		exit(0);
		break;
	case 'p':
	case 'P':
		kjorer = !kjorer;
		break;
	case '+':
		ps->maxIT++; if(ps->maxIT > 30) ps->maxIT = 30;
		printf("MAX_IT = %d\n", ps->maxIT);
		break;
		case '-':
		ps->maxIT--; if(ps->maxIT < 1) ps->maxIT = 1;
		printf("MAX_IT = %d\n", ps->maxIT);
		break;
		case 'r':
			ps->reset();
			kjorer = false;
			break;
	default:
		break;
	}
}
void mouse(int key, int opp, int x, int y)
{
	rot[X] = rot[Y] = 0; //zpos = 0;
	forrigeX = x;
	forrigeY = y;
	// opp = [1 --> opp, == 0 -> ned]
	if(key == GLUT_LEFT_BUTTON)
	{
		venstre = (opp == 0);
	}
	else if(key == GLUT_MIDDLE_BUTTON)
	{
		midt = (opp == 0);
	}
	else if(key == GLUT_RIGHT_BUTTON)
	{
		hoyre = (opp == 0);
	}
	
}
void motion(int x, int y)
{
	int dx = forrigeX - x;
	int dy = forrigeY - y;
	if(venstre)
	{
		rot[Y] = steg*dx;
		rot[X] = steg*dy;
	}
	if(midt)
	{
	}
	if(hoyre)
	{
		zpos += dx/100.0;
	}
		
		
	forrigeX = x;
	forrigeY = y;

}


void initFunksjoner()
{
	glewInit();	
}

void main(int argc, char **argv)
{
	glutInit(&argc, argv);
    glutInitWindowSize(800, 600);
	glutInitWindowPosition(0, 0);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_DEPTH);
    glutCreateWindow("Cloth simulation on the GPU");
	initFunksjoner();
    
	Texture::initTextureClass();
	
	ps = new ParticleSystemGPU(ii, ii);
	
    

    glutDisplayFunc(display);
    glutMouseFunc(mouse);
    glutMotionFunc(motion);
    glutIdleFunc(idle);
    glutKeyboardFunc(keyboard);
    glutReshapeFunc(reshape);

    
	
    glutMainLoop();

    
}