#pragma once
 #include <stdio.h>
#define NULL 0
#define SIGMA1 0.00001
void error(char *feilmelding);
#define Equals(a, b) (a-SIGMA1 <= b && b <= a+SIGMA1)
class Matrix3x3
{
public:
	Matrix3x3(){}

	void kopier(Matrix3x3 &m)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j<  3; j++)
			{
				d[i][j] = m.d[i][j];
			}
		}
	}
	Matrix3x3 inverse()
	{
		Matrix3x3 retur = *this;

		retur.d[0][0] = 1/d[0][0];
		retur.d[1][1] = 1/d[1][1];
		retur.d[2][2] = 1/d[2][2];

		
		return retur;
	}
	void NullStill()
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j<  3; j++)
			{
				d[i][j] = 0;
			}
		}
	}
	inline const Matrix3x3 &operator-=(const Matrix3x3 &m)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				d[i][j] -= m.d[i][j];
			}
		}
		return *this;
	}
	inline const Matrix3x3 &operator+=(const Matrix3x3 &m)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				d[i][j] += m.d[i][j];
			}
		}
		return *this;
	}
		
	inline Matrix3x3 operator-(const Matrix3x3 &m)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = d[i][j] - m.d[i][j];
			}
		}
		return retur;
	}

	inline Matrix3x3 operator+(const Matrix3x3 &m)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = d[i][j] + m.d[i][j];
			}
		}
		return retur;
	}

	inline Matrix3x3 operator*(float da)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = d[i][j] * da;
				
			}
		}
		return retur;
	}
	inline const Matrix3x3 &operator+(float da)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				d[i][j] *= da;
			}
		}
		return *this;
	}
	inline Matrix3x3 operator*(const Matrix3x3 &m)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = 0;
				for(int k = 0; k < 3; k++)
				{
					retur.d[i][j] += d[i][k] * m.d[k][j];
				}
			}
		}
		return retur;
	}
	float d[3][3];
};
class Node
{
private:
	Node(int i, int j, Matrix3x3 d, Node *n = NULL) :
		r(i), c(j), data(d), neste(n)
		{
		}
public:
	
	~Node()
	{
		neste = 0;
	}
	Matrix3x3 data;
	Node *neste;
	int r, c;
	static bool rekursivSlett;
	static inline Node *GetNode(int i, int j, Matrix3x3 *d, Node *n = NULL)
	{
		if(nNoder == 0) 
		{
			if(d == NULL) 
			{
				Matrix3x3 temp; temp.NullStill();
				return new Node(i, j, temp, n);
			}
			else
			{
				return new Node(i, j, *d, n);
			}
		}
		
		nNoder--;
		noder[nNoder]->r = i; noder[nNoder]->c = j; noder[nNoder]->neste = n;

		if(d != 0) noder[nNoder]->data.kopier(*d); 
		else noder[nNoder]->data.NullStill();
		return noder[nNoder];

	}
	static inline void returnNode(Node *old)
	{
		if(nNoder == MAX)
		{
			utvid();
		}
		noder[nNoder++] = old;
	}
	static inline void utvid()
	{
		Node **ny = new Node*[MAX*2];

		for(int i = 0; i < MAX; i++)
		{
			ny[i] = noder[i];
		}
		delete[] noder;
		noder = ny;
		MAX *= 2;
	}
	

	static Node** noder;
	static int nNoder;
	static int MAX;

	
	
};
class SMatrise
{
public:
	static float UGYLDIG;
	SMatrise() : r(0), c(0), row(0)
	{}
	SMatrise(int h, int b) : r(h), c(b) 
	{
		row = new Node*[r];
		for(int i = 0; i < r; i++) row[i] = 0;
	}
	~SMatrise()
	{
		if(row != NULL)
		{
			
			for(int i = 0; i < r; i++)
			{
				Node *p = row[i];
				while(p != NULL)
				{
					Node *neste = p->neste;
					Node::returnNode(p);
					p = neste;
					
				}
			}
			delete[] row;
			
			row = 0;
		}
	}
	Node **row;
	

	int r, c;

	// Denne metoden fungerer under prinsippet at om en bruker funksjonen (i, j), s velger en et element som skal vre i den sparse matrisen
	inline Matrix3x3 &operator()(int i, int j)
	{
		if(i < 0 || j < 0 || r <= i || c <= j) error("Feil i SMatrise::operator()\n");
		if(row[i] == NULL)
		{
			Node *nyNode = Node::GetNode(i, j, 0);
			SettInn(nyNode);
			return nyNode->data;
		}
		
		Node *p = row[i];
		while(p != NULL)
		{
			if(p->c == j) return p->data;
			p = p->neste;
		}
		Node *nyNode = Node::GetNode(i, j, 0);
		SettInn(nyNode);
		return nyNode->data;
	}




	inline void NullStill()
	{
		for(int i = 0; i < r; i++)
		{
			//printf("Sletter node\n");
			
			Node *p = row[i];
			while(p != NULL)
			{
				Node *neste = p->neste;
				Node::returnNode(p);
				p = neste;
			}
			row[i] = 0;
		}
		
	}

	inline void SettInn(Node *ny)
	{
		if(row[ny->r] == NULL)
		{
			row[ny->r] = ny;
		}
		else if(row[ny->r]->c >= ny->c)
		{
			ny->neste = row[ny->r];
			row[ny->r] = ny;
		}
		else
		{
			Node *forrige = row[ny->r], *p = forrige->neste;
			while(p != NULL)
			{
				if(p->c >= ny->c)
				{
					forrige->neste = ny;
					ny->neste = p;
					
					return;
				}
				forrige = p;
				p = p->neste;
			}
			forrige->neste = ny;
		}
	}

	
		
	inline void Endre(int nr, int nc)
	{
		if(row != NULL)
		{
			for(int i = 0; i < r; i++)
			{
				Node *p = row[i];
				while(p != NULL)
				{
					Node::returnNode(p);
					p = p->neste;
				}
			}
			if(r != nr)
			{
				delete[] row;
				row = new Node*[nr];
			}
		}
		else
		{
			row = new Node*[nr];
		}
		
		
		r = nr; c = nc;
		
		for(int i = 0; i < nr; i++) row[i] = 0;
		
	}



};

class IMatrise
{
public:
	IMatrise() : l(0), data(0) {}
	IMatrise(int i, float null = 1) : l(i)
	{
		data = new float[i];
		for(int i = 0; i < l; i++) data[i] = null;
	}
	~IMatrise()
	{
		if(data != NULL) delete[] data;
		data = NULL;
	}
	inline void Endre(int n)
	{
		l = n;
		if(data != 0) delete[] data;
		data = new float[l];
		for(int i = 0; i < l; i++) data[i] = 1;
	}
	float *data; int l;
	inline float &operator()(int i)
	{
		if(i < 0 || l <= i) error("Feil i IMatrise::operator()\n");
		return data[i];
	}
	void skriv()
	{
		for(int i = 0; i < l; i++)
		{
			printf("%lf\t", data[i]);
		}
		printf("\n");
	}

};
struct Array
{
public:
	Array() : l(0), data(0) {}
	int l;
	float *data;
	Array(int lengde) : l(lengde)
	{
		data = new float[l];
		for(int i = 0; i < l; i++) data[i] = 0;
	}
	~Array()
	{
		if(data != 0)
		{
			delete[] data;
			data = 0;
		}
	}
	inline void Endre(int n)
	{
		if(l != n)
		{
			l = n;
			if(data != 0) delete[] data;
			data = new float[l];
		}
		for(int i = 0; i < l; i++) data[i] = 0;
	}
	inline void NullStill()
	{
		for(int i = 0; i < l; i++)
		{
			data[i] = 0;
		}
	}
	
	inline float &operator()(int i)
	{
		if(i < 0 || l < i) error("Feil i Array::operator()\n");
		return data[i];
	}
	void skriv()
	{
		for(int i = 0; i < l; i++)
		{
			printf("%lf\t", data[i]);
		}
		printf("\n");
	}
	void skrivTilFil(char *filnavn)
	{
		FILE *skriv;
		fopen_s(&skriv, filnavn, "w");
		for(int i = 0; i < l; i++)
		{
			fprintf(skriv, "%lf\t", data[i]);
		}
		fclose(skriv);
	}

};



inline void mulS(Array &res, SMatrise &m, Array &a)
{
	for(int i = 0; i < m.r; i++)
	{
		Node *p = m.row[i];
		res(i) = 0;
		while(p != NULL)
		{
			//res(i) += p->data * a(p->c);
			p = p->neste;
		}
	}
}

inline void mul(Array &res, SMatrise &m, Array &a, bool test = false)
{
	// Skal multiplisere 3x3 matrisen i m med vektoren i a og legge svaret som vektor i res
	//Node nullNode(0, 0, 0, 0);
	Node *null = Node::GetNode(0, 0, 0, 0);
	for(int i = 0; i < m.r; i++)
	{
		Node *p = m.row[i];
		
		res(3*i) = 0;
		res(3*i+1) = 0;
		res(3*i+2) = 0;
		//printf("Ganger\n");
		while(p != NULL)
		{
			if(test)
			{
				printf("Ganger(p->c == %d)\n", p->c);
				printf("[%lf, %lf, %lf]\n", p->data.d[0][0], p->data.d[0][1], p->data.d[0][2]);
				printf("[%lf, %lf, %lf]\n", p->data.d[1][0], p->data.d[1][1], p->data.d[1][2]);
				printf("[%lf, %lf, %lf]\n", p->data.d[2][0], p->data.d[2][1], p->data.d[2][2]);
				printf("med\n");
				printf("[%lf, %lf, %lf]\n\n", a(3*p->c), a(3*p->c+1), a(3*p->c+2));
			}
			res(3*i    ) += p->data.d[0][0] * a(3*p->c) + p->data.d[0][1] * a(3*p->c+1) + p->data.d[0][2] * a(3*p->c+2);
			res(3*i + 1) += p->data.d[1][0] * a(3*p->c) + p->data.d[1][1] * a(3*p->c+1) + p->data.d[1][2] * a(3*p->c+2);
			res(3*i + 2) += p->data.d[2][0] * a(3*p->c) + p->data.d[2][1] * a(3*p->c+1) + p->data.d[2][2] * a(3*p->c+2);
			p = p->neste;
		}
		if(test) 
		{
			printf("Blir\n");
			printf("[%lf, %lf, %lf]\n", res(3*i), res(3*i+1), res(3*i+2));
			getchar();
		}
	}
}
inline void mul(SMatrise &res, SMatrise &m, float d)
{
	res.NullStill();
	Node *temp = Node::GetNode(0, 0, 0, 0), *temp2 = temp;
	for(int i = 0; i < m.r; i++)
	{
		temp = temp2;
		temp->neste = 0;
		Node *p = m.row[i];
		Node *nyNode = 0;
		while(p != NULL)
		{
			nyNode = Node::GetNode(p->r, p->c, 0, 0);
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = p->data.d[i][j] * d;
			temp->neste = nyNode;
			temp = nyNode;
			p = p->neste;
		}
		res.row[i] = temp2->neste;
	}
	temp2->neste = 0;
	Node::returnNode(temp2);
}
inline void mul(SMatrise &res, IMatrise &I, SMatrise &S)
{
	res.NullStill();
	for(int i = 0; i < I.l; i++)
	{
		if(!Equals(I(i), 0))
		{
			Node *p = S.row[i];
			while(p != NULL)
			{
				res(p->r, p->c) = p->data * I(i);
				p = p->neste;
			}
		}
	}
}

inline void mul(Array &res, Array &a, float d)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) * d;
	}
}

inline void mul(float &res, Array &a, Array &b)
{
	res = 0;
	for(int i = 0; i < a.l; i++)
	{
		res += a(i) * b(i);
	}
}
inline void mul(IMatrise &res, IMatrise &a, float d)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) * d;
	}
}

inline void mul(Array &res, IMatrise &m, Array &a)
{
	for(int i = 0; i < m.l; i++)
	{
		res(i) = m(i) * a(i);
	}
}


inline void sum(SMatrise &res, SMatrise &a, SMatrise &b)
{
	res.NullStill();
	Node *temp = Node::GetNode(0, 0, 0, 0), *temp2 = temp;
	for(int i = 0; i < a.r; i++)
	{
		Node *pa = a.row[i];
		Node *pb = b.row[i];
		temp = temp2;
		temp->neste = 0;
		Node *nyNode = 0;
		while(pa != NULL && pb != NULL)
		{
			if(pa->c == pb->c)
			{
				//res(pa->r, pa->c) 
				nyNode = Node::GetNode(pa->r, pa->c, 0, 0);
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j] + pb->data.d[i][j];
				pa = pa->neste;
				pb = pb->neste;
			}
			else if(pa->c < pb->c)
			{
				nyNode = Node::GetNode(pa->r, pa->c, 0, 0); 
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j];
				pa = pa->neste;
			}
			else
			{
				nyNode = Node::GetNode(pb->r, pb->c, 0, 0); 
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pb->data.d[i][j];
				pb = pb->neste;
				
			}
			temp->neste = nyNode;
			temp = nyNode;
		}
		while(pa != NULL)
		{
			nyNode = Node::GetNode(pa->r, pa->c, 0, 0); 
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j];
			pa = pa->neste;
			temp->neste = nyNode;
			temp = nyNode;
		}
		while(pb != NULL)
		{
			nyNode = Node::GetNode(pb->r, pb->c, 0, 0); 
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pb->data.d[i][j];
			pb = pb->neste;
			temp->neste = nyNode;
			temp = nyNode;
		}
		res.row[i] = temp2->neste;
	}
	temp2->neste = 0;
	Node::returnNode(temp2);
}

inline void sum(Array &res, Array &a, Array &b)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) + b(i);
	}
}


inline void minus(SMatrise &res, SMatrise &a, SMatrise &b)
{
	res.NullStill();
	for(int i = 0; i < a.r; i++)
	{
		Node *pa = a.row[i];
		Node *pb = b.row[i];
		while(pa != NULL && pb != NULL)
		{
			if(pa->c == pb->c)
			{
				res(pa->r, pa->c) = pa->data - pb->data;
				pa = pa->neste;
				pb = pb->neste;
			}
			else if(pa->c < pb->c)
			{
				res(pa->r, pa->c) = pa->data;
				pa = pa->neste;
			}
			else
			{
				res(pb->r, pb->c) = pb->data*-1;
				pb = pb->neste;
			}
		}
		while(pa != NULL)
		{
			res(pa->r, pa->c) = pa->data;
			pa = pa->neste;
		}
		while(pb != NULL)
		{
			res(pb->r, pb->c) = pb->data*-1;
			pb = pb->neste;
		}
	}
}

inline void minus(Array &res, Array &a, Array &b)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) - b(i);
	}
}