#include "ParticleSystemGPU.h"

void Error(char *sz)
{
	printf(sz);
	getchar();
}

ParticleSystemGPU::ParticleSystemGPU(int width, int height) : w(width), h(height), dt(0.01f), ks(10000.f), kd(.00001f)
{
	mA.Endre(w*h, w*h);
	DVen.Endre(3*w*h);
	
	
	// Initialiserer CG-programmene
	char *verParNavn1[] = { "size" }; int verAntPar1 = 1;
	char *verParNavn2[] = { "size", "indA", "indB", "Var" }; int verAntPar2 = 4;


	char *fraParNavn1[] = { "P0", "V0", "rest", "ks", "kd", "size" }; int fraAntPar1 = 6;
	char *fraParNavn2[] = { "P0", "V0", "rest", "ks", "kd", "sizeBIG", "size" }; int fraAntPar2 = 7;
	char *fraParNavn3[] = { "P0", "V0", "ks", "kd", "sizeBIG", "size" }; int fraAntPar3 = 6;
	// char *fraParNavn4[] = { "tex", "size" }; int fraAntPar4 = 2;
	char *fraParNavn5[] = { "V0", "DV", "dt", "size" }; int fraAntPar5 = 4;
	char *fraParNavn6[] = { "V0", "DV", "P0", "dt", "size" }; int fraAntPar6 = 5;
	char *fraParNavn7[] = { "M", "dfdv0", "dfdv1", "dfdv2", "dfdx0", "dfdx1", "dfdx2", "dt", "size", "sizeS" }; int fraAntPar7 = 10;
	char *fraParNavn8[] = { "M0", "M1", "M2", "S", "Vek", "size", "sizeBIG", "faktor" }; int fraAntPar8 = 8;
	char *fraParNavn9[] = { "v0", "v1", "var", "p", "size", "indA", "indB" }; int fraAntPar9 = 7;
	char *fraParNavn10[] = { "v0", "v1", "var", "p", "size", "indA", "indB" }; int fraAntPar10 = 7;
	char *fraParNavn11[] = { "v0", "v1", "var", "p", "size", "indA", "indB" }; int fraAntPar11 = 7;
	char *fraParNavn12[] = { "IMat", "S", "Vek", "pos", "size", "faktor" }; int fraAntPar12 = 6;
	char *fraParNavn13[] = { "v0", "v1", "p", "size", "faktor" }; int fraAntPar13 = 5;
	char *fraParNavn14[] = { "A0", "A1", "A2", "size" }; int fraAntPar14 = 4;
	char *fraParNavn15[] = { "M0", "M1", "M2", "size" }; int fraAntPar15 = 4;
	char *fraParNavn16[] = { "v0", "v1", "size" }; int fraAntPar16 = 3;
	char *fraParNavn17[] = { "v", "forrigeSize", "size" }; int fraAntPar17 = 3;
	char *fraParNavn18[] = { "v", "size", "indA", "indB", "var" }; int fraAntPar18 = 5;
	char *fraParNavn19[] = { "v", "S", "size" }; int fraAntPar19 = 3;
	char *fraParNavn20[] = { "A0", "A1", "A2", "inv0", "inv1", "inv2", "dv0", "b", "size" }; int fraAntPar20 = 9;
	char *fraParNavn21[] = { "A0", "A1", "A2", "size" }; int fraAntPar21 = 4;

	m_cgBeregnF = new CGStruct("library.cg", "beregnF.cg", verParNavn1, verAntPar1, fraParNavn1, fraAntPar1, "mainVertex1", "main");
	m_cgBeregnDFDX = new CGStruct("library.cg", "beregnDFDX.cg", verParNavn1, verAntPar1, fraParNavn2, fraAntPar2, "mainVertex1", "main");
	m_cgBeregnDFDV = new CGStruct("library.cg", "beregnDFDV.cg", verParNavn1, verAntPar1, fraParNavn3, fraAntPar3, "mainVertex1", "main");
	// m_cgLinkSparse = new CGStruct(NULL, "linkSparse.cg", NULL, 0, fraParNavn4, fraAntPar4, NULL, "main");

	m_cgItererV0 = new CGStruct(NULL, "itererV0.cg", NULL, 0, fraParNavn5, fraAntPar5, NULL, "main");
	m_cgItererP0 = new CGStruct(NULL, "itererP0.cg", NULL, 0, fraParNavn6, fraAntPar6, NULL, "main");

	m_cgGenererA = new CGStruct(NULL, "genererA.cg", NULL, 0, fraParNavn7, fraAntPar7, NULL, "main");
	m_cgMulSMatVek = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn8, fraAntPar8, NULL, "mulSMatVekFil");
	m_cgSumVekVek = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn9, fraAntPar9, NULL, "sumVekVek");
	m_cgMinusVekVek = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn10, fraAntPar10, NULL, "minusVekVek");
	m_cgMulVekVek = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn11, fraAntPar11, NULL, "mulVekVek");
	m_cgMulIMatVek = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn12, fraAntPar12, NULL, "mulIMatVekFil");
	m_cgSumVekVekA = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn13, fraAntPar13, NULL, "sumVekVekA");

	m_cgGenererP = new CGStruct(NULL, "genererP.cg", NULL, 0, fraParNavn14, fraAntPar14, NULL, "genP");
	m_cgGenererP1 = new CGStruct(NULL, "genererP.cg", NULL, 0, fraParNavn14, fraAntPar14, NULL, "genP1");

	m_cgSumRekke = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn15, fraAntPar15, NULL, "sumRekke");
	m_cgHalver = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn17, fraAntPar17, NULL, "halver");
	m_cgMulPiksel = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn16, fraAntPar16, NULL, "mulPiksel");
	m_cgKopier = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn18, fraAntPar18, NULL, "kopier");

	m_cgFilter = new CGStruct(NULL, "library.cg", NULL, 0, fraParNavn19, fraAntPar19, NULL, "filter");

	m_cgJacobi = new CGStruct(NULL, "jacobi.cg", NULL, 0, fraParNavn20, fraAntPar20, NULL, "Jacobi");
	m_cgInvert = new CGStruct(NULL, "jacobi.cg", NULL, 0, fraParNavn21, fraAntPar21, NULL, "Invert");


	char *verParNavn[] = { "P0", "pos", "size", "mv" }; int verParAnt = 4;
	m_cgDrawResult = new CGStruct("drawResult.cg", NULL, verParNavn, verParAnt, NULL, 0, "main", NULL);

	maxIT = 10;
	
	// Initialiserer teksturene
	printf("(%d, %d)\n", w, h);
	GLfloat *rest = new GLfloat[26*w*h*4]; if(rest) for(int i = 0; i < 26*w*h*4; i++) rest[i] = 0;//1.0;
	GLfloat *pos = new GLfloat[w*h*4]; for(int i = 0; i < w*h*4; i++) pos[i] = 0;//i/4.f;
	GLfloat *vel = new GLfloat[w*h*4]; for(int i = 0; i < w*h*4; i++) vel[i] = 0;//0.1f*(i/4);//i/2.f;
	GLfloat *dv = new GLfloat[w*h*4]; for(int i = 0; i < w*h*4; i++) dv[i] = 0;//0.1f*i;
	GLfloat *mass = new GLfloat[w*h*4]; for(int i = 0; i < w*h*4; i++) mass[i] = 1.f;
	GLfloat *S = new GLfloat[w*h*3*4]; 
	GLfloat *blank = new GLfloat[w*h*4];
	GLfloat *blankS = new GLfloat[w*h*26*3*4];
	for(int i = 0; i < 4*w*h; i++) blank[i] = 0;
	for(int i = 0; i < 4*w*h*3*26; i++) blankS[i] = 0;
	
	for(int i = 0; i < 3*w*h*4; i++) S[i] = 0;
	for(int i = 0; i < h; i++)
	{
		int ipos = 3 * i * w * 4;
		for(int j = 0; j < w; j++)
		{
			int pos1 = ipos + j * 4;
			int pos2 = ipos + (j + w) * 4;
			int pos3 = ipos + (j + 2 * w) * 4;
			for(int k = 0; k < 3; k++)
			{
				S[pos1+k] = S[pos2+k] = S[pos3+k] = 0;
			}

			if(!(i == 0)) 
				S[pos1] = S[pos2+1] = S[pos3+2] = 1;

		}
	}
	//skriv("S.txt", w, 3*h, S);
		
	for(int i = 0; i < w; i++)
	{
		for(int j = 0; j < h; j++)
		{
			pos[i*w*4+j*4+0] = (GLfloat)j;
			pos[i*w*4+j*4+1] = (GLfloat)i;			
			pos[i*w*4+j*4+2] = 0;
			pos[i*w*4+j*4+3] = 1;
		}
	}

	
	m_tF = new Texture(Texture::FLOAT, pos, w, h);
	m_tRest = new Texture(Texture::FLOAT, rest, 26, w*h);
	m_tDFDX0 = new Texture(Texture::FLOAT, 26, w*h);
	m_tDFDX1 = new Texture(Texture::FLOAT, 26, w*h);
	m_tDFDX2 = new Texture(Texture::FLOAT, 26, w*h);
	m_tDFDV0 = new Texture(Texture::FLOAT, 26, w*h);
	m_tDFDV1 = new Texture(Texture::FLOAT, 26, w*h);
	m_tDFDV2 = new Texture(Texture::FLOAT, 26, w*h);

	
	
	m_tP0 = new Texture(Texture::FLOAT, pos, w, h);
	m_tV0 = new Texture(Texture::FLOAT, vel, w, h);
	m_tP1 = new Texture(Texture::FLOAT, pos, w, h);
	m_tV1 = new Texture(Texture::FLOAT, vel, w, h);
	
	m_tB = new Texture(Texture::FLOAT, blank, w, h);
	m_tB1 = new Texture(Texture::FLOAT, blank, w, h);
	m_tA0 = new Texture(Texture::FLOAT, 26, w*h);
	m_tA1 = new Texture(Texture::FLOAT, 26, w*h);
	m_tA2 = new Texture(Texture::FLOAT, 26, w*h);
	
	m_tAP = new Texture(Texture::FLOAT, blank, w, h);
	m_tAP1 = new Texture(Texture::FLOAT, blank, w, h);
	m_tM = new Texture(Texture::FLOAT, mass, w, h);
	m_tS = new Texture(Texture::FLOAT, S, w, 3*h);
	m_tY = new Texture(Texture::FLOAT, blank, w, h);
	m_tAP = new Texture(Texture::FLOAT, blank, w, h);
	m_tAP1 = new Texture(Texture::FLOAT, blank, w, h);
	m_tAtlas = new Texture(Texture::FLOAT, 5*w, 2*h);

	m_tR0 = new Texture(Texture::FLOAT, w, h);
	m_tR1 = new Texture(Texture::FLOAT, w, h);
	m_tQS = new Texture(Texture::FLOAT, w, h);
	m_tDV0 = new Texture(Texture::FLOAT, w, h);
	m_tDV1 = new Texture(Texture::FLOAT, w, h);
	m_tC0 = new Texture(Texture::FLOAT, w, h);
	m_tC1 = new Texture(Texture::FLOAT, w, h);
	m_tVar = new Texture(Texture::FLOAT, w, h);
	m_tHalv0 = new Texture(Texture::FLOAT, w, h);
	m_tHalv1 = new Texture(Texture::FLOAT, w, h);

	m_tInv0 = new Texture(Texture::FLOAT, w, h);
	m_tInv1 = new Texture(Texture::FLOAT, w, h);
	m_tInv2 = new Texture(Texture::FLOAT, w, h);
	m_tInvTest = new Texture(Texture::FLOAT, w, h);
	CheckError("Etter teksturer");

	delete[] pos;
	delete[] vel;
	delete[] dv;
	delete[] rest;
	delete[] S;
	delete[] mass;


	
	// Inititaliserer Framebufrene og bufferene
	
	
	glGenFramebuffersEXT(50, m_fb);
	m_buf[F] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[Y] = GL_COLOR_ATTACHMENT1_EXT;

	m_buf[DFDX0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[DFDX1] = GL_COLOR_ATTACHMENT1_EXT;
	m_buf[DFDX2] = GL_COLOR_ATTACHMENT2_EXT;
	//m_buf[DFDXl] = GL_COLOR_ATTACHMENT1_EXT;
	m_buf[DFDV0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[DFDV1] = GL_COLOR_ATTACHMENT1_EXT;
	m_buf[DFDV2] = GL_COLOR_ATTACHMENT2_EXT;
	//m_buf[DFDVl] = GL_COLOR_ATTACHMENT3_EXT;

	
	m_buf[P0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[P1] = GL_COLOR_ATTACHMENT1_EXT;
	
	m_buf[V0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[V1] = GL_COLOR_ATTACHMENT1_EXT;

	
	m_buf[A0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[A1] = GL_COLOR_ATTACHMENT1_EXT;
	m_buf[A2] = GL_COLOR_ATTACHMENT2_EXT;

	m_buf[B] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[B1] = GL_COLOR_ATTACHMENT1_EXT;

	m_buf[AP] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[AP1] = GL_COLOR_ATTACHMENT1_EXT;

	m_buf[R0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[R1] = GL_COLOR_ATTACHMENT1_EXT;
	m_buf[QS] = GL_COLOR_ATTACHMENT2_EXT;

	m_buf[DV0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[DV1] = GL_COLOR_ATTACHMENT1_EXT;

	
	m_buf[C0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[C1] = GL_COLOR_ATTACHMENT1_EXT;
	m_buf[VAR] = GL_COLOR_ATTACHMENT2_EXT;

	m_buf[HALV0] = GL_COLOR_ATTACHMENT0_EXT;
	m_buf[HALV1] = GL_COLOR_ATTACHMENT1_EXT;

	m_buf[ATLAS] = GL_COLOR_ATTACHMENT0_EXT;
	CheckError("Etter FB-gen");


	
	// Kobler opp teksturer til fb objektene
	m_tDraw = new Draw*[100];
	m_tDraw[F] = new DrawObject(m_tF, m_fb[FB_F], m_buf[F]);

	m_tDraw[DFDX] = new MatrixDrawObject(m_tDFDX0, m_tDFDX1, m_tDFDX2, m_fb[FB_DFDX], m_buf[DFDX0], m_buf[DFDX1], m_buf[DFDX2]);
	m_tDraw[DFDV] = new MatrixDrawObject(m_tDFDV0, m_tDFDV1, m_tDFDV2, m_fb[FB_DFDV], m_buf[DFDV0], m_buf[DFDV1], m_buf[DFDV2]);

	m_tDraw[P0] = new DrawObject(m_tP0, m_fb[FB_BP0], m_buf[P0]);
	m_tDraw[P1] = new DrawObject(m_tP1, m_fb[FB_BP0], m_buf[P1]);

	m_tDraw[V0] = new DrawObject(m_tV0, m_fb[FB_BP1], m_buf[V0]);
	m_tDraw[V1] = new DrawObject(m_tV1, m_fb[FB_BP1], m_buf[V1]);

	m_tDraw[B] = new DrawObject(m_tB, m_fb[FB_GEN_B], m_buf[B]);
	m_tDraw[B1] = new DrawObject(m_tB1, m_fb[FB_GEN_B], m_buf[B1]);

	m_tDraw[AP] = new DrawObject(m_tAP, m_fb[FB_GEN_AP], m_buf[AP]);
	m_tDraw[AP1] = new DrawObject(m_tAP1, m_fb[FB_GEN_AP], m_buf[AP1]);

	m_tDraw[A] = new MatrixDrawObject(m_tA0, m_tA1, m_tA2, m_fb[FB_GEN_A], m_buf[A0], m_buf[A1], m_buf[A2]);


	m_tDraw[ATLAS] = new DrawObject(m_tAtlas, m_fb[FB_ATLAS], m_buf[ATLAS]);

	/*m_tDraw[R0] =	 new DrawObjectAtlas(m_tDraw[ATLAS], 0,		0, w, h);
	m_tDraw[R1] =	 new DrawObjectAtlas(m_tDraw[ATLAS], w,		0, w, h);
	m_tDraw[QS] =	 new DrawObjectAtlas(m_tDraw[ATLAS], 2*w,	0, w, h);
	m_tDraw[DV0] =	 new DrawObjectAtlas(m_tDraw[ATLAS], 3*w,	0, w, h);
	m_tDraw[DV1] =	 new DrawObjectAtlas(m_tDraw[ATLAS], 4*w,	0, w, h);
	m_tDraw[C0] =	 new DrawObjectAtlas(m_tDraw[ATLAS], 0,		h, w, h);
	m_tDraw[C1] =	 new DrawObjectAtlas(m_tDraw[ATLAS], w,		h, w, h);
	m_tDraw[VAR] =	 new DrawObjectAtlas(m_tDraw[ATLAS], 2*w,	h, w, h);
	m_tDraw[HALV0] = new DrawObjectAtlas(m_tDraw[ATLAS], 3*w,	h, w, h);
	m_tDraw[HALV1] = new DrawObjectAtlas(m_tDraw[ATLAS], 4*w,	h, w, h);*/

	m_tDraw[R0] =	 new DrawObject(m_tR0, m_fb[FB_LOOP0], m_buf[R0]);
	m_tDraw[R1] =	 new DrawObject(m_tR1, m_fb[FB_LOOP0], m_buf[R1]);
	m_tDraw[QS] =	 new DrawObject(m_tQS, m_fb[FB_LOOP0], m_buf[QS]);
	m_tDraw[DV0] =	 new DrawObject(m_tDV0, m_fb[FB_LOOP2], m_buf[DV0]);
	m_tDraw[DV1] =	 new DrawObject(m_tDV1, m_fb[FB_LOOP2], m_buf[DV1]);
	m_tDraw[C0] =	 new DrawObject(m_tC0, m_fb[FB_LOOP1], m_buf[C0]);
	m_tDraw[C1] =	 new DrawObject(m_tC1, m_fb[FB_LOOP1], m_buf[C1]);
	m_tDraw[VAR] =	 new DrawObject(m_tVar, m_fb[FB_LOOP1], m_buf[VAR]);
	m_tDraw[HALV0] = new DrawObject(m_tHalv0, m_fb[FB_HALVER], m_buf[HALV0]);
	m_tDraw[HALV1] = new DrawObject(m_tHalv1, m_fb[FB_HALVER], m_buf[HALV1]);

	m_tDraw[Y] = new DrawObject(m_tY, m_fb[FB_F], m_buf[Y]);
	
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
}

ParticleSystemGPU::~ParticleSystemGPU(void)
{
	delete m_cgBeregnF; delete m_cgBeregnDFDX; delete m_cgBeregnDFDV; delete m_cgItererP0; delete m_cgItererV0; delete m_cgDrawResult;
}



#pragma region BeregnKrefter

/*************************************************************
**	BeregnKrefter bruker data fra teksturene:
**		m_tP0
**		m_tV0
**		m_tRest
**
**	Den klargjr m_tF, m_tDFDX, m_tDFDV og m_tDFDXl for bruk seinere
*************************************************************/
void ParticleSystemGPU::beregnKrefter()
{
	
	long tider[16];
	tider[0] = clock();
	// Initialiserer fb objektet
	m_tDraw[F]->EnableDraw();
	
	piksler += w*h;


	//////////////START/////////////////////////////////// 
	// Skal frst beregne F utifra P0 og V0

	// Laster inn cg-programmet
	m_cgBeregnF->loadBoth();
	m_tDraw[P0]->EnableRead(GL_TEXTURE0_ARB, m_cgBeregnF->fraPar[0]);
	m_tDraw[V0]->EnableRead(GL_TEXTURE1_ARB, m_cgBeregnF->fraPar[1]);
	m_tRest->BindTexture(GL_TEXTURE2_ARB, m_cgBeregnF->fraPar[2]);
	
	cgGLSetParameter1f(m_cgBeregnF->fraPar[3], ks);
	cgGLSetParameter1f(m_cgBeregnF->fraPar[4], kd);
	cgGLSetParameter2f(m_cgBeregnF->fraPar[5], (GLfloat)w, (GLfloat)h);
	cgGLSetParameter2f(m_cgBeregnF->verPar[0], (GLfloat)w, (GLfloat)h);
	

	// Initialiserer F som output
	glViewport(0, 0, w, h);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgBeregnF->unloadBoth();
	//////////////SLUTT///////////////////////////////////////
	tider[1] = clock();
	
	
	
	
	
	
	
	piksler += 26*w*h;
	m_tDraw[DFDX]->EnableDraw();
	
	
	//////////////START///////////////////////////////////////
	// Skal generere DFDX
	m_cgBeregnDFDX->loadBoth();
	
	m_tDraw[P0]->EnableRead(GL_TEXTURE0, m_cgBeregnDFDX->fraPar[0]);
	m_tDraw[V0]->EnableRead(GL_TEXTURE1, m_cgBeregnDFDX->fraPar[1]);
	m_tRest->BindTexture(GL_TEXTURE2, m_cgBeregnDFDX->fraPar[2]);
	
	cgGLSetParameter1f(m_cgBeregnDFDX->fraPar[3], ks);
	cgGLSetParameter1f(m_cgBeregnDFDX->fraPar[4], kd);
	cgGLSetParameter2f(m_cgBeregnDFDX->fraPar[5], (GLfloat)(26), (GLfloat)(w*h));
	cgGLSetParameter2f(m_cgBeregnDFDX->fraPar[6], (GLfloat)w, (GLfloat)h);
	
	cgGLSetParameter2f(m_cgBeregnDFDX->verPar[0], (GLfloat)(26), (GLfloat)(w*h));
	
	glViewport(0, 0, 26, w*h);
	glClear(GL_COLOR_BUFFER_BIT);
	drawQuad(); 
	
	// Laster ut DFDX-cg-programmet
	m_cgBeregnDFDX->unloadBoth();
	tider[2] = clock();
	
	piksler += 26*w*h;



	m_tDraw[DFDV]->EnableDraw();
	//////////////START///////////////////////////////////////
	// Skal generere DFDV
	m_cgBeregnDFDV->loadBoth();
	m_tDraw[P0]->EnableRead(GL_TEXTURE0_ARB, m_cgBeregnDFDV->fraPar[0]);
	m_tDraw[V0]->EnableRead(GL_TEXTURE1_ARB, m_cgBeregnDFDV->fraPar[1]);
	cgGLSetParameter1f(m_cgBeregnDFDV->fraPar[2], ks);
	cgGLSetParameter1f(m_cgBeregnDFDV->fraPar[3], kd);
	cgGLSetParameter2f(m_cgBeregnDFDV->fraPar[4], (GLfloat)(26), (GLfloat)(w*h));
	cgGLSetParameter2f(m_cgBeregnDFDV->fraPar[5], (GLfloat)w, (GLfloat)h);

	cgGLSetParameter2f(m_cgBeregnDFDV->verPar[0], (GLfloat)(26), (GLfloat)(w*h));

	glViewport(0, 0, 26, w*h);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	drawQuad();

	// Laster ut DFDV-cg-programmet
	m_cgBeregnDFDV->unloadBoth();
	//////////////SLUTT///////////////////////////////////////
	tider[4] = clock();
	

	glFlush();
	
	// Skal summerer alle rekker og legge -svaret i diagonalen
	piksler += 2*w*h;
	m_cgSumRekke->loadFragment();

	m_tDraw[DFDX]->EnableRead(GL_TEXTURE0_ARB, GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, m_cgSumRekke->fraPar[0], m_cgSumRekke->fraPar[1], m_cgSumRekke->fraPar[2]);
		
	cgGLSetParameter2f(m_cgSumRekke->fraPar[3], (GLfloat)(26), (GLfloat)(w*h));
	glViewport(0, 0, 26, w*h);
	
	m_tDraw[DFDX]->EnableDraw();
	
	glLineWidth(1); // TODO!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! sjekk om denne faktisk alltid vil aktivere skriving til de 3 pikslene per kolonne den skal skrive til, tekstur er kvadratisk
	glBegin(GL_LINES);
	glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 0, 0); glVertex3f(-1, -1, -0.5f);
	glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 0, 1); glVertex3f(-1, 1, -0.5f);
	glEnd();
	
	tider[3] = clock();

	m_tDraw[DFDV]->EnableRead(GL_TEXTURE0_ARB, GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, m_cgSumRekke->fraPar[0], m_cgSumRekke->fraPar[1], m_cgSumRekke->fraPar[2]);
	m_tDraw[DFDV]->EnableDraw();
	glBegin(GL_LINES);
	glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 0, 0); glVertex3f(-1, -1, -0.5f);
	glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 0, 1); glVertex3f(-1, 1, -0.5f);
	glEnd();
	m_cgSumRekke->unloadFragment();
	//////////////SLUTT///////////////////////////////////////
	CheckError("Etter beregnKrefter\n");

	glFlush();
	

}
#pragma endregion Inneholder funksjoner som gjelder spesielt for BeregnKrefter


void SparseGPUToCPU(ParticleSystemGPU *p, SMatrise &A, GLuint fb, GLuint buf0, GLuint buf1, GLuint buf2, int w, int h)
{
	static Pixel *a0 = new Pixel[26*w*h];
	static Pixel *a1 = new Pixel[26*w*h];
	static Pixel *a2 = new Pixel[26*w*h];
	p->les(fb, buf0, 26, 3*w*h, (GLfloat*)a0);
	p->les(fb, buf1, 26, 3*w*h, (GLfloat*)a1);
	p->les(fb, buf2, 26, 3*w*h, (GLfloat*)a2);
	
	for(int y = 0; y < w*h; y++)
	{
		int Y = y;
		A(Y, Y).d[0][0] = a0[y*26].p[0];
		A(Y, Y).d[0][1] = a0[y*26].p[1];
		A(Y, Y).d[0][2] = a0[y*26].p[2];

		A(Y, Y).d[1][0] = a1[y*26].p[0];
		A(Y, Y).d[1][1] = a1[y*26].p[1];
		A(Y, Y).d[1][2] = a1[y*26].p[2];

		A(Y, Y).d[2][0] = a2[y*26].p[0];
		A(Y, Y).d[2][1] = a2[y*26].p[1];
		A(Y, Y).d[2][2] = a2[y*26].p[2];
		for(int x = 1; x < 26; x++)
		{
			int xo = (x-1)%5-2;
			int yo = (x-1)/5-2;
			int y1 = Y/w + yo;
			int x1 = Y%w + xo;
			
			int X = y1*w+x1;
			if(x1 < 0 || w <= x1 || y1 < 0 || h <= y1 || X < 0 || w*h <= X || x == 13) continue;

			A(Y, X).d[0][0] = a0[y*26+x].p[0];
			A(Y, X).d[0][1] = a0[y*26+x].p[1];
			A(Y, X).d[0][2] = a0[y*26+x].p[2];

			A(Y, X).d[1][0] = a1[y*26+x].p[0];
			A(Y, X).d[1][1] = a1[y*26+x].p[1];
			A(Y, X).d[1][2] = a1[y*26+x].p[2];

			A(Y, X).d[2][0] = a2[y*26+x].p[0];
			A(Y, X).d[2][1] = a2[y*26+x].p[1];
			A(Y, X).d[2][2] = a2[y*26+x].p[2];
			//printf("Skriver A(%d, %d).d[%d][%d]\n", Y, X, (y%3), 4);
			

			
		}
	}
	
}
void VekGPUToCPU(ParticleSystemGPU *p, Array &v, GLuint fb, GLuint buf, int w, int h)
{
	GLfloat *temp = new GLfloat[w*h*4];
	p->les(fb, buf, w, h, temp);
	int k = 0;
	for(int i = 0; i < 4*w*h; i++)
	{
		if((i+1)%4 == 0) continue;

		v(k++) = temp[i];
	}
	delete[] temp;
}
void IMatGPUToCPU(ParticleSystemGPU *p, IMatrise &v, GLuint fb, GLuint buf, int w, int h)
{
	GLfloat *temp = new GLfloat[w*h*4];
	p->les(fb, buf, w, h, temp);
	int k = 0;
	for(int i = 0; i < 4*w*h; i++)
	{
		if((i+1)%4 == 0) continue;

		v(k++) = temp[i];
	}
	delete[] temp;
}
#pragma region CG-Solver
/*************************************************************
**	CGSolver bruker data fra teksturene:
**		m_tM
**		m_tDFDX/m_tDFDV/m_tDFDXl
**		m_tF
**		m_tV0
**		m_tY
**		m_S
**
**	Den klargjr m_tDV for bruk seinere
*************************************************************/
void ParticleSystemGPU::CGSolver(GLfloat delta_tid, int maxIT)
{
	dt = delta_tid;
	
	long tider[20];
	tider[0] = clock();
	m_tDraw[A]->EnableDraw();
	piksler += 26*w*h;

	
	//////////////START/////////////////////////////////// 
	// Skal frst generere A = M - dt * dfdv - dt * dt * dfdx

	// Laster inn cg-programmet
	m_cgGenererA->loadFragment();
	m_tM->BindTexture(GL_TEXTURE0_ARB, m_cgGenererA->fraPar[0]);
	m_tDraw[DFDV]->EnableRead(GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, GL_TEXTURE3_ARB, m_cgGenererA->fraPar[1], m_cgGenererA->fraPar[2], m_cgGenererA->fraPar[3]);
	m_tDraw[DFDX]->EnableRead(GL_TEXTURE4_ARB, GL_TEXTURE5_ARB, GL_TEXTURE6_ARB, m_cgGenererA->fraPar[4], m_cgGenererA->fraPar[5], m_cgGenererA->fraPar[6]);
	
	cgGLSetParameter1f(m_cgGenererA->fraPar[7], dt);
	cgGLSetParameter2f(m_cgGenererA->fraPar[8], (GLfloat)(26), (GLfloat)(w*h));
	cgGLSetParameter2f(m_cgGenererA->fraPar[9], (GLfloat)(w), (GLfloat)(h));

	// Initialiserer A som output
	
	glViewport(0, 0, 26, w*h);
	drawQuad();

	// Laster ut cg-programmet
	m_cgGenererA->unloadFragment();
	//////////////SLUTT///////////////////////////////////////
	
	

	
	tider[1] = clock();
	
	
	//////////////START/////////////////////////////////// 
	// Skal generere b(b = F + dt * dfdx * v0)
	// Er en 3-stegs prosess:
	// 1. Summere y og v0 og gange med dt samtidig
	// 2. Gange dfdx med resultat fra 1
	// 3. Summere F og resultat fra 2 og samtidig gange med dt

	SumA(m_tDraw[B1], m_tDraw[V0], m_tDraw[Y], w, h, dt);
	
	tider[3] = clock();
	Multiply(m_tDraw[B], m_tDraw[DFDX], m_tS, m_tDraw[B1], w, h);
	
		
	tider[4] = clock();
	SumA(m_tDraw[B1], m_tDraw[F], m_tDraw[B], w, h, 1);
	tider[5] = clock();

	Filter(m_tDraw[B], m_tDraw[B1], m_tS, w, h);
	
	static SMatrise mA;
	static Array mb;
	static Array mdv;
	static GLfloat *dv_data= new GLfloat[4*w*h];
	static bool forste = true;
	if(forste)
	{
		mA.Endre(w*h, w*h);
		mb.Endre(3*w*h);
		mdv.Endre(3*w*h);
		initHjelp(w*h);
		forste = false;
	}
	MatrixDrawObject *temp = (MatrixDrawObject*)m_tDraw[A];
	SparseGPUToCPU(this, mA, temp->m_fb, temp->buffers[0], temp->buffers[1], temp->buffers[2], w, h);
	VekGPUToCPU(this, mb, m_tDraw[B]->m_fb, m_tDraw[B]->m_buf, w, h);
	deleVerdi = w;
	
	CGSolverTest(mdv, mA, mb);
	for(int i = 0; i < w*h; i++)
	{
		dv_data[4*i] = mdv(3*i);
		dv_data[4*i+1] = mdv(3*i+1);
		dv_data[4*i+2] = mdv(3*i+2);
		dv_data[4*i+3] = 0;
	}
	glBindTexture(GL_TEXTURE_RECTANGLE_NV, m_tDraw[DV1]->m_t->getTID());
	glTexImage2D(GL_TEXTURE_RECTANGLE_NV, 0, GL_FLOAT_RGBA32_NV, w, h, 0, GL_BGRA_EXT, GL_FLOAT, dv_data);
	return;
	Kopier(m_tDraw[DV0], m_tDraw[F], w, h);
	
	
		
	
	lagP(m_tDraw[AP], m_tDraw[AP1], m_tDraw[A], w, h);
	
	// CG-solveren
	//glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb[FB_LOOP1]);
	int sigmaInd[4] = { 0, 1, 0, 2 };
	// sigmaNull = m_tVar[0][0]
	// sigmaNy = m_tVar[0][1]
	// alfa = m_tVar[0][3]
	// sigmaOld = m_tVar[0][2]

	// TODO: dv = z, lagres i m_tDV1
	
	
	Kopier(m_tDraw[DV0], m_tDraw[F], w, h);
	
	Filter(m_tDraw[DV1], m_tDraw[DV0], m_tS, w, h);
	
	
	
	static IMatrise aAP(3*w*h);
	static Array aB(3*w*h);
	static Array aQS(3*w*h);
	static Array aDV1(3*w*h);
	static Array aDiff(3*w*h);
	static Array aRes(3*w*h);
	float fRes;
	
	/////////////////////////////////////////////////
	// sigmaNull = bT*P*b
	// temp = P*b
	MultiplyI(m_tDraw[QS], m_tDraw[AP], m_tS, m_tDraw[B], w, h, 1); // Er rett i forhold til CPU-versjon
	
	
	tider[6] = clock();
	MultiplyV(m_tDraw[VAR], m_tDraw[B], m_tDraw[QS], w, h, 0, 0); // Er rett i forhold til CPU-versjon
	tider[7] = clock();
	

	
	
	// r = b - A * dv
	// temp = A * dv
	Multiply(m_tDraw[QS], m_tDraw[A], m_tS, m_tDraw[DV1], w, h, 1); // Er rett i forhold til CPU-versjon
	
	// r = b - temp
	Minus(m_tDraw[R1], m_tDraw[B], m_tDraw[QS], w, h);  // Er rett i forhold til CPU-versjonen
	tider[9] = clock();	
	
	
	// c = P1 * r
	MultiplyI(m_tDraw[C1], m_tDraw[AP1], m_tS, m_tDraw[R1], w, h); // Er rett i forhold til CPU-versjon
	tider[10] = clock();


	// sigmaNy = rT * c
	MultiplyV(m_tDraw[VAR], m_tDraw[R1], m_tDraw[C1], w, h, sigmaInd[0], sigmaInd[1]); // Er rett i forhold til CPU_versjon
	tider[11] = clock();
	
	glReadBuffer(m_buf[VAR]);
	GLfloat sigma[2];
	glReadPixels(0, 0, 1, 2, GL_RED, GL_FLOAT, sigma);
	glReadBuffer(GL_NONE);
	tider[12] = clock();
	GLfloat sigmaNull = sigma[0];

	float epsilon = 0.0000001;//1e-22;//.000000000001f;
	int it = 0;
	
	//printf("sigma[0] = %lf\nsigma[1] = %lf\n", sigma[0], sigma[1]);
	int steps = 0; // Holder p antall instruksjoner som skal kjres i lkken
	int loops = 4; // Sier hvilken loop det skal sluttes i
	int stop_step = -1; // er E [1..8]
	glFlush();
	//GLfloat sigma[4];
	while(it++<maxIT && sigma[1] > 0.00001 * sigmaNull/*3*(w+h)/2*/)//sigma[1] > epsilon * sigmaNull && it++ < 2*(w+h)/2)
	{
		steps = -1;
		INCR_BREAK(it, loops, steps, stop_step);
		//printf("Kjrer en iterasjon\n");
		// q = A * c
		Multiply(m_tDraw[QS], m_tDraw[A], m_tS, m_tDraw[C1], w, h); // Er rett i forhold til CPU-versjonen
		glFlush();
		
		
		
		INCR_BREAK(it, loops, steps, stop_step);
		
		
		// alfa = sigmaNy / (cT*q) <--> alfa1 = (cT*q)/sigmaNy
		MultiplyV(m_tDraw[VAR], m_tDraw[C1], m_tDraw[QS], w, h, 0, 3, -1, -1, sigmaInd[0], sigmaInd[1]); // Er rett i forhold til cpu-versjonen
		glFlush();
		INCR_BREAK(it, loops, steps, stop_step);

		//glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb[FB_LOOP1]);
		// dv = dv + alfa*c
		Sum(m_tDraw[DV0], m_tDraw[DV1], m_tDraw[C1], w, h, -1, -1, 0, 3);
		glFlush();
		INCR_BREAK(it, loops, steps, stop_step);
		

		// r = r - alfa * q
		Minus(m_tDraw[R0], m_tDraw[R1], m_tDraw[QS], w, h, -1, -1, 0, 3);
		glFlush();
		INCR_BREAK(it, loops, steps, stop_step);
	

		SWAP(Draw*, m_tDraw[R0], m_tDraw[R1]);
		SWAP(Draw*, m_tDraw[DV0], m_tDraw[DV1]);

		
		// glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb[FB_LOOP0]);

		// s = P1 * r
		MultiplyI(m_tDraw[QS], m_tDraw[AP1], m_tS, m_tDraw[R1], w, h);
		glFlush();
		INCR_BREAK(it, loops, steps, stop_step);

		// sigmaOld = sigmaNy
		SWAP(int, sigmaInd[0], sigmaInd[2]);
		SWAP(int, sigmaInd[1], sigmaInd[3]);

		// sigmaNy = rT * s
		MultiplyV(m_tDraw[VAR], m_tDraw[R1], m_tDraw[QS], w, h, sigmaInd[0], sigmaInd[1]);
		glFlush();
		INCR_BREAK(it, loops, steps, stop_step);

		// c = s + sNy/sOld * c
		Sum(m_tDraw[C0], m_tDraw[QS], m_tDraw[C1], w, h, sigmaInd[0], sigmaInd[1], sigmaInd[2], sigmaInd[3]);
		Filter(m_tDraw[C1], m_tDraw[C0], m_tS, w, h);
		glFlush();
		//Filter(m_fb[FB_LOOP1], m_buf[C1], m_tC0, m_tS, w, h);
		INCR_BREAK(it, loops, steps, stop_step);
		//glFlush();

		/*SWAP(Texture *, m_tC0, m_tC1);
		SWAP(GLuint, m_buf[C0], m_buf[C1]);*/
		//if(it % 15 == 0)
		{
			glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb[FB_LOOP1]);
			glReadBuffer(m_buf[VAR]);
			GLfloat vari[4];
			glReadPixels(0, 0, 1, 4, GL_RED, GL_FLOAT, vari);
			glReadBuffer(GL_NONE);
			//printf("sigma == %lf\n", sigma[1]);
			glReadBuffer(0);
			// printf("Vari\n%lf\n%lf\n%lf\n%lf\n\n", vari[0], vari[1], vari[2], vari[3]);
		}
		INCR_BREAK(it, loops, steps, stop_step);
	}
	//printf("%lf < %lf || %d >= 100\n", sigma[1], epsilon*sigma[0], it);
	tider[13] = clock();
	//if(it >= 100)
	{
		//printf("Det ble brukt %d iterasjoner\n", it);
		//getchar();
	}
	for(int i = 1; i < 14; i++)
	{
		//printf("Tiden mellom %d og %d er %dms, %d er gtt siden starten\n", i-1, i, ((tider[i]-tider[i-1])), tider[i]-tider[0]);
	}
#ifdef _DEBUG
	/*Multiply(m_fb[FB_LOOP1], m_buf[QS], m_tA, m_tS, m_tDV1, w, h, 1);
	Minus(m_fb[FB_GEN_B], m_buf[AP], m_tB, m_tQS, w, h);
	Filter(m_fb[FB_GEN_B], m_buf[AP1], m_tAP, m_tS, w, h);
	Array APMat2; APMat2.Endre(3*w*h);
	VekGPUToCPU(this, APMat2, m_fb[FB_GEN_B], m_buf[AP], w, h);
	double nullen;
	APMat2(0) = 0;
	APMat2(1) = 0;
	APMat2(2) = 0;
	mul(nullen, APMat2, APMat2);
	printf("Diff var %lf\n", nullen);*/
#endif
	//if(false)

	{
		Filter(m_tDraw[DV0], m_tDraw[DV1], m_tS, w, h);
		SWAP(Draw *, m_tDraw[DV0], m_tDraw[DV1]);
	}

	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
	
	
	
}
void ParticleSystemGPU::Jacobi(GLfloat delta_tid, int maxIT)
{
	dt = delta_tid;
	//dt = 0.01;
	//maxIT = 10;
	long tider[20];
	tider[0] = clock();
	m_tDraw[A]->EnableDraw();
	piksler += 26*w*h;

start:
	//////////////START/////////////////////////////////// 
	// Skal frst generere A = M - dt * dfdv - dt * dt * dfdx

	// Laster inn cg-programmet
	m_cgGenererA->loadFragment();
	m_tM->BindTexture(GL_TEXTURE0_ARB, m_cgGenererA->fraPar[0]);
	m_tDraw[DFDV]->EnableRead(GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, GL_TEXTURE3_ARB, m_cgGenererA->fraPar[1], m_cgGenererA->fraPar[2], m_cgGenererA->fraPar[3]);
	m_tDraw[DFDX]->EnableRead(GL_TEXTURE4_ARB, GL_TEXTURE5_ARB, GL_TEXTURE6_ARB, m_cgGenererA->fraPar[4], m_cgGenererA->fraPar[5], m_cgGenererA->fraPar[6]);
	
	cgGLSetParameter1f(m_cgGenererA->fraPar[7], dt);
	cgGLSetParameter2f(m_cgGenererA->fraPar[8], (GLfloat)(26), (GLfloat)(w*h));
	cgGLSetParameter2f(m_cgGenererA->fraPar[9], (GLfloat)(w), (GLfloat)(h));

	// Initialiserer A som output
	
	glViewport(0, 0, 26, w*h);
	drawQuad();

	// Laster ut cg-programmet
	m_cgGenererA->unloadFragment();
	//////////////SLUTT///////////////////////////////////////
	m_cgInvert->loadFragment();
	GLuint buffer[4] = {GL_COLOR_ATTACHMENT0_EXT, GL_COLOR_ATTACHMENT1_EXT, GL_COLOR_ATTACHMENT2_EXT, GL_COLOR_ATTACHMENT3_EXT };
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb[FB_INVERT]);
	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,buffer[0],GL_TEXTURE_RECTANGLE_NV,m_tInv0->getTID(),0);
	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,buffer[1],GL_TEXTURE_RECTANGLE_NV,m_tInv1->getTID(),0);
	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,buffer[2],GL_TEXTURE_RECTANGLE_NV,m_tInv2->getTID(),0);
	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,buffer[3],GL_TEXTURE_RECTANGLE_NV,m_tInvTest->getTID(),0);
	glDrawBuffers(4, buffer);
	
	m_tDraw[A]->EnableRead(GL_TEXTURE0_ARB, GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, m_cgInvert->fraPar[0], m_cgInvert->fraPar[1], m_cgInvert->fraPar[2]);
	cgGLSetParameter2f(m_cgInvert->fraPar[3], w, h);
	glViewport(0, 0, w, h);
	drawQuad();
	m_cgInvert->unloadFragment();
	

	
	tider[1] = clock();
	
	
	//////////////START/////////////////////////////////// 
	// Skal generere b(b = F + dt * dfdx * v0)
	// Er en 3-stegs prosess:
	// 1. Summere y og v0 og gange med dt samtidig
	// 2. Gange dfdx med resultat fra 1
	// 3. Summere F og resultat fra 2 og samtidig gange med dt

	SumA(m_tDraw[B1], m_tDraw[V0], m_tDraw[Y], w, h, dt);
	
	tider[3] = clock();
	Multiply(m_tDraw[B], m_tDraw[DFDX], m_tS, m_tDraw[B1], w, h);
	
		
	tider[4] = clock();
	SumA(m_tDraw[B1], m_tDraw[F], m_tDraw[B], w, h, 1);
	tider[5] = clock();

	Filter(m_tDraw[B], m_tDraw[B1], m_tS, w, h);



	Kopier(m_tDraw[DV0], m_tDraw[F], w, h);
	

	// Kjrer jacobi-iterasjonene
	int stopp = 1;
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_tDraw[DV0]->m_fb);
	m_tDraw[B]->EnableRead(GL_TEXTURE7_ARB, m_cgJacobi->fraPar[7]);
	cgGLSetParameter2f(m_cgJacobi->fraPar[8], w, h);
	m_cgJacobi->loadFragment();
	m_tDraw[A]->EnableRead(GL_TEXTURE0_ARB, GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, m_cgJacobi->fraPar[0], m_cgJacobi->fraPar[1], m_cgJacobi->fraPar[2]);
	m_tInv0->BindTexture(GL_TEXTURE3_ARB, m_cgJacobi->fraPar[3]);
	m_tInv1->BindTexture(GL_TEXTURE4_ARB, m_cgJacobi->fraPar[4]);
	m_tInv2->BindTexture(GL_TEXTURE5_ARB, m_cgJacobi->fraPar[5]);
	
	static Texture temp(Texture::FLOAT, w, h);
	for(int step = 0; step < maxIT; step++)
	{
//		CGStruct::kall++;
		// glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,GL_COLOR_ATTACHMENT0_EXT,GL_TEXTURE_RECTANGLE_NV,temp.getTID(),0);
		glDrawBuffer(m_tDraw[DV1]->m_buf);
		m_tDraw[DV0]->EnableRead(GL_TEXTURE6_ARB, m_cgJacobi->fraPar[6]);
		
		//m_tDraw[DV1]->EnableDraw();
		
		drawQuad();
		

		// Filter(m_tDraw[DV0], m_tDraw[DV1], m_tS, w, h);
		SWAP(Draw *, m_tDraw[DV0], m_tDraw[DV1]);
	}
	m_cgJacobi->unloadFragment();
	
	Filter(m_tDraw[DV1], m_tDraw[DV0], m_tS, w, h);
}
void ParticleSystemGPU::lagP(Draw *ap, Draw *ap1, Draw *A, int ww, int hh)
{
	

	piksler += 2*w*h;
	ap->EnableDraw();
	m_cgGenererP->loadFragment();

	A->EnableRead(GL_TEXTURE0_ARB, GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, m_cgGenererP->fraPar[0], m_cgGenererP->fraPar[1], m_cgGenererP->fraPar[2]);
	cgGLSetParameter2f(m_cgGenererP->fraPar[3], (GLfloat)(ww), (GLfloat)(hh));
	
	// cgGLSetParameter1f(m_cgSumVekVekA->fraPar[4], faktor);


	// Initialiserer P0 som output
	
	
	//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgGenererP->unloadFragment();


	ap1->EnableDraw();
	m_cgGenererP1->loadFragment();

	A->EnableRead(GL_TEXTURE0_ARB, GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, m_cgGenererP->fraPar[0], m_cgGenererP->fraPar[1], m_cgGenererP->fraPar[2]);
	cgGLSetParameter2f(m_cgGenererP->fraPar[3], (GLfloat)(ww), (GLfloat)(hh));
	
	// cgGLSetParameter1f(m_cgSumVekVekA->fraPar[4], faktor);


	// Initialiserer P0 som output
	
	
	//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgGenererP1->unloadFragment();
}

	


#pragma endregion Inneholder funksjoner som gjelder spesielt for CG-solver


#pragma region BeregnPosisjon


void ParticleSystemGPU::beregnPosisjon()
{
	

	piksler += 2*w*h;

	//////////////START/////////////////////////////////// 
	// Skal frst beregne ny P0 utifra V0 og DV

	
	
	m_tDraw[P1]->EnableDraw();

	// Laster inn cg-programmet
	m_cgItererP0->loadFragment();
	m_tDraw[V0]->EnableRead(GL_TEXTURE0_ARB, m_cgItererP0->fraPar[0]);
	m_tDraw[DV1]->EnableRead(GL_TEXTURE1_ARB, m_cgItererP0->fraPar[1]);
	m_tDraw[P0]->EnableRead(GL_TEXTURE2_ARB, m_cgItererP0->fraPar[2]);
	cgGLSetParameter1f(m_cgItererP0->fraPar[3], dt);
	cgGLSetParameter2f(m_cgItererP0->fraPar[4], w, h);


	// Initialiserer P0 som output
	glViewport(0, 0, w, h);
	drawQuad();
	glFlush();

	// Laster ut cg-programmet
	m_cgItererP0->unloadFragment();
	//////////////SLUTT///////////////////////////////////////

	
	//getchar();

	

	

	//////////////START/////////////////////////////////// 
	// Skal frst beregne ny V0 utifra DV

	m_tDraw[V1]->EnableDraw();

	// Laster inn cg-programmet
	m_cgItererV0->loadFragment();
	m_tDraw[V0]->EnableRead(GL_TEXTURE0_ARB, m_cgItererV0->fraPar[0]);
	m_tDraw[DV1]->EnableRead(GL_TEXTURE1_ARB, m_cgItererV0->fraPar[1]);
	cgGLSetParameter1f(m_cgItererV0->fraPar[2], dt);
	cgGLSetParameter2f(m_cgItererV0->fraPar[3], w, h);


	// Initialiserer V0
	glViewport(0, 0, w, h);
	drawQuad();

	// Laster ut cg-programmet
	m_cgItererV0->unloadFragment();
	//////////////SLUTT///////////////////////////////////////


	// Bytter om p P0<-->P1 og V0<-->V1
	SWAP(Draw *, m_tDraw[P0], m_tDraw[P1]);
	SWAP(Draw *, m_tDraw[V0], m_tDraw[V1]);

	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
	
	
	//{ GLfloat *temp = new GLfloat[4*w*h]; les(m_fb[FB_BP1], m_buf[V0], w, h, temp); skriv("V_test.txt", w, h, temp); delete[] temp; }
	//{ GLfloat *temp = new GLfloat[4*w*h]; les(m_fb[FB_LOOP2], m_buf[DV1], w, h, temp); skriv("DV_test.txt", w, h, temp); delete[] temp;}

}
#pragma endregion Inneholder funksjoner som gjelder spesielt for BeregnPosisjon

void ParticleSystemGPU::tegn(bool test)
{
	static Pixel *Pos = new Pixel[w*h];

	les(m_fb[FB_BP0], m_buf[P0], w, h, (GLfloat*)Pos);
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
	if(false)
	{
		glPointSize(5);
		glBegin(GL_POINTS);
		for(int i = 0; i < h; i++)
		{
			for(int j = 0; j < w; j++)
			{
				glVertex3f(Pos[i*w+j].p[0], Pos[i*w+j].p[1], Pos[i*w+j].p[2]);
				
			}
		}
		glEnd();
	}
	else if(true)
	{
		glBegin(GL_LINES);
		for(int i = 0; i < h; i++)
		{
			for(int j = 0; j < w-1; j++)
			{
				glVertex3f(Pos[i*w+j].p[0], Pos[i*w+j].p[1], Pos[i*w+j].p[2]);
				glVertex3f(Pos[i*w+j+1].p[0], Pos[i*w+j+1].p[1], Pos[i*w+j+1].p[2]);

			}
		}
		for(int i = 0; i < h-1; i++)
		{
			for(int j = 0; j < w; j++)
			{
				glVertex3f(Pos[i*w+j].p[0], Pos[i*w+j].p[1], Pos[i*w+j].p[2]);
				glVertex3f(Pos[(i+1)*w+j].p[0], Pos[(i+1)*w+j].p[1], Pos[(i+1)*w+j].p[2]);

			}
		}
		glEnd();
	}




	return;
	static bool forste = true;
	static int listen;
	
	m_cgDrawResult->loadVertex();
	m_tP0->BindTexture(GL_TEXTURE0_ARB, m_cgDrawResult->verPar[0]);
	cgGLSetStateMatrixParameter(m_cgDrawResult->verPar[3], CG_GL_MODELVIEW_PROJECTION_MATRIX, CG_GL_MATRIX_IDENTITY);
	if(forste)
	{
		//printf("Kjrer med vertex-shader\n");
		
		
	
		// cgGLSetMatrixParameterdr(m_cgDrawResult->verPar[4], tab);
		listen = glGenLists(1);
		glNewList(listen, GL_COMPILE_AND_EXECUTE);	
		glBegin(GL_LINES);
		for(int i = 1; i < w; i++)
		{
			for(int j = 1; j < h; j++)
			{
				glTexCoord2f(i, j); glVertex3f(i, j, 0);
				glTexCoord2f(i-1, j-1); glVertex3f(i-1, j-1, 0);
				
				glTexCoord2f(i-1, j); glVertex3f(i-1, j, 0);
				glTexCoord2f(i, j); glVertex3f(i, j, 0);
				
				glTexCoord2f(i, j-1); glVertex3f(i, j-1, 0);
				glTexCoord2f(i, j); glVertex3f(i, j, 0);
				
			}
		}
		for(int i = 0; i < w-1; i++)
		{
			glTexCoord2f(i, 0); glVertex3f(i, 0, 0);
			glTexCoord2f(i+1, 0); glVertex3f(i+1, 0, 0);
			glTexCoord2f(0, i); glVertex3f(0, i, 0);
			glTexCoord2f(0, i+1); glVertex3f(0, i+1, 0);

		}
		glEnd();
		
		glEndList();
		
		forste = false;
	}
	else
	{
		glCallList(listen);
	}

	m_cgDrawResult->unloadVertex();
	
	
}




#pragma region Iterer
void ParticleSystemGPU::iterer()
{
	piksler = 0;
	
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(-1, 1, -1, 1, -1, 1);
	glMatrixMode(GL_MODELVIEW);

	// Lagrer staten
	GLint currentDraw, vp[4];
	glDisable(GL_DEPTH_TEST);
	glGetIntegerv(GL_DRAW_BUFFER, &currentDraw);
	glGetIntegerv(GL_VIEWPORT, vp);
	glViewport(0, 0, w, h);
	// Ferdig lagre staten

	long tid1 = clock();
	beregnKrefter();

	
	kd = 0.1;
	GLfloat delta_tid = 0.01;
	ks = 10000;//*(0.01/delta_tid)*0.5;
	
	// CGSolver(delta_tid, maxIT);
	Jacobi(delta_tid, maxIT);
	
	beregnPosisjon();
	
	skrivAlleTeksturerTilFiler();
	
	
	// Gr tilbake igjen
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glViewport(vp[0], vp[1], vp[2], vp[3]);
	glDrawBuffer(currentDraw);
	glEnable(GL_DEPTH_TEST);
}
#pragma endregion Inneholder Itererings-metoder

#pragma region Library

void ParticleSystemGPU::Kopier(Draw *res, Draw *t, int ww, int hh)
{
	piksler += ww*hh;
	res->EnableDraw();
	m_cgKopier->loadFragment();
	t->EnableRead(GL_TEXTURE0_ARB, m_cgKopier->fraPar[0]);
	cgGLSetParameter2f(m_cgKopier->fraPar[1], ww, hh);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glViewport(0, 0, ww, hh);
	drawQuad();
	m_cgKopier->unloadFragment();
}
void ParticleSystemGPU::drawQuad()
{
	CheckError("1");
	glLoadIdentity();	
	CheckError("2");
	glBegin(GL_QUADS);
    {
        glMultiTexCoord2fARB(GL_TEXTURE0, 0, 0); glVertex3f(-1, -1, -.5f);
        glMultiTexCoord2fARB(GL_TEXTURE0, 1, 0); glVertex3f( 1, -1, -.5f);
        glMultiTexCoord2fARB(GL_TEXTURE0, 1, 1); glVertex3f( 1,  1, -.5f);
        glMultiTexCoord2fARB(GL_TEXTURE0, 0, 1); glVertex3f(-1,  1, -.5f);
    }
    glEnd();
	CheckError("3");
	
}
void ParticleSystemGPU::Filter(Draw *res, Draw *t, Texture *S, int ww, int hh)
{
	piksler += ww*hh;
	res->EnableDraw();
	
	m_cgFilter->loadFragment();
	t->EnableRead(GL_TEXTURE0_ARB, m_cgFilter->fraPar[0]);
	S->BindTexture(GL_TEXTURE1_ARB, m_cgFilter->fraPar[1]);
	cgGLSetParameter2f(m_cgFilter->fraPar[2], w, h);
	glViewport(0, 0, ww, hh);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	m_cgFilter->unloadFragment();
}
void ParticleSystemGPU::Sum(Draw *res, Draw *v0, Draw *v1, int ww, int hh, int x0, int y0, int x1, int y1)
{
	piksler += ww*hh;
	res->EnableDraw();

	// Laster inn cg-programmet
	m_cgSumVekVek->loadFragment();
	v0->EnableRead(GL_TEXTURE0_ARB, m_cgSumVekVek->fraPar[0]);
	v1->EnableRead(GL_TEXTURE1_ARB, m_cgSumVekVek->fraPar[1]);
	m_tDraw[VAR]->EnableRead(GL_TEXTURE2_ARB, m_cgSumVekVek->fraPar[2]);
	cgGLSetParameter2f(m_cgSumVekVek->fraPar[4], (GLfloat)(ww), (GLfloat)(hh));
	cgGLSetParameter2f(m_cgSumVekVek->fraPar[5], (GLfloat)(x0), (GLfloat)(y0));
	cgGLSetParameter2f(m_cgSumVekVek->fraPar[6], (GLfloat)(x1), (GLfloat)(y1));
	// cgGLSetParameter1f(m_cgSumVekVek->fraPar[4], faktor);


	// Initialiserer P0 som output
	glViewport(0, 0, ww, hh);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgSumVekVek->unloadFragment();
}

void ParticleSystemGPU::SumA(Draw *res, Draw *v0, Draw *v1, int ww, int hh, float faktor)
{
	piksler += ww*hh;
	res->EnableDraw();

	// Laster inn cg-programmet
	m_cgSumVekVekA->loadFragment();
	v0->EnableRead(GL_TEXTURE0_ARB, m_cgSumVekVekA->fraPar[0]);
	v1->EnableRead(GL_TEXTURE1_ARB, m_cgSumVekVekA->fraPar[1]);
	cgGLSetParameter2f(m_cgSumVekVekA->fraPar[3], (GLfloat)(ww), (GLfloat)(hh));
	cgGLSetParameter1f(m_cgSumVekVekA->fraPar[4], faktor);
	
	// cgGLSetParameter1f(m_cgSumVekVekA->fraPar[4], faktor);


	// Initialiserer output
	glViewport(0, 0, ww, hh);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgSumVekVekA->unloadFragment();
}

void ParticleSystemGPU::Minus(Draw *res, Draw *v0, Draw *v1, int ww, int hh, int x0, int y0, int x1, int y1)
{
	piksler += ww*hh;
	res->EnableDraw();

	// Laster inn cg-programmet
	m_cgMinusVekVek->loadFragment();
	v0->EnableRead(GL_TEXTURE0_ARB, m_cgMinusVekVek->fraPar[0]);
	v1->EnableRead(GL_TEXTURE1_ARB, m_cgMinusVekVek->fraPar[1]);
	m_tDraw[VAR]->EnableRead(GL_TEXTURE2_ARB, m_cgMinusVekVek->fraPar[2]);
	cgGLSetParameter2f(m_cgMinusVekVek->fraPar[4], (GLfloat)(ww), (GLfloat)(hh));
	cgGLSetParameter2f(m_cgMinusVekVek->fraPar[5], (GLfloat)(x0), (GLfloat)(y0));
	cgGLSetParameter2f(m_cgMinusVekVek->fraPar[6], (GLfloat)(x1), (GLfloat)(y1));
	// cgGLSetParameter1f(m_cgMinusVekVek->fraPar[4], faktor);


	// Initialiserer output
	glViewport(0, 0, ww, hh);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgMinusVekVek->unloadFragment();
}

void ParticleSystemGPU::MultiplyV(Draw *res, Draw *v0, Draw *v1, int ww, int hh, int x, int y, int x0, int y0, int x1, int y1)
{	piksler += ww*hh;
	// Frst skal jeg gange piksel for piksel
	m_tDraw[HALV0]->EnableDraw();

	m_cgMulPiksel->loadFragment();
	v0->EnableRead(GL_TEXTURE0_ARB, m_cgMulPiksel->fraPar[0]);
	v1->EnableRead(GL_TEXTURE1_ARB, m_cgMulPiksel->fraPar[1]);
	cgGLSetParameter2f(m_cgMulPiksel->fraPar[2], (GLfloat)ww, (GLfloat)hh);
	
	glViewport(0, 0, ww, hh);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();
	m_cgMulPiksel->unloadFragment();

	// Skal n halvere bredden og hyden for  summere sammen 4 og 4 verdier
	int wi = ww, hi = hh, fhi = hh, fwi = ww;
	m_cgHalver->loadFragment();
	while(!(wi == 1 && hi == 1))
	{
		piksler += wi*hi;
		fwi = wi; fhi = hi;
		wi /= 2;
		hi /= 2;
		if(wi == 0) wi = 1;
		if(hi == 0) hi = 1;
		m_tDraw[HALV1]->EnableDraw();
		m_tDraw[HALV0]->EnableRead(GL_TEXTURE0_ARB, m_cgHalver->fraPar[0]);

		cgGLSetParameter2f(m_cgHalver->fraPar[1], fwi, fhi);
		cgGLSetParameter2f(m_cgHalver->fraPar[2], wi, hi);
		
		glViewport(0, 0, wi, hi);

		drawQuad();
		
		SWAP(Draw*, m_tDraw[HALV0], m_tDraw[HALV1]);
		
	}
	m_cgHalver->unloadFragment();


	/*GLfloat *res = new GLfloat[ww*hh*4];
	les(fb, buf, wi, hi, res); skriv("testhalv.txt", wi, hi, res);
	les(fb, buf2, fwi, fhi, res); skriv("testhalv2.txt", fwi, fhi, res);


	getchar();*/
	res->EnableDraw();
	m_cgKopier->loadFragment();
	m_tDraw[HALV0]->EnableRead(GL_TEXTURE0_ARB, m_cgKopier->fraPar[0]);
	m_tDraw[VAR]->EnableRead(GL_TEXTURE1_ARB, m_cgKopier->fraPar[4]);
	cgGLSetParameter2f(m_cgKopier->fraPar[1], 0, 0);
	cgGLSetParameter2f(m_cgKopier->fraPar[2], x0, y0);
	cgGLSetParameter2f(m_cgKopier->fraPar[3], x1, y1);
	piksler += 1;
	glViewport(x, y, 1, 1);
	//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	m_cgKopier->unloadFragment();

	
}
void ParticleSystemGPU::MultiplyVOld(GLuint fb, GLuint buf, Texture *v0, Texture *v1, int ww, int hh, int x, int y, int x0, int y0, int x1, int y1)
{
	if(fb != 0) glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);

	// Laster inn cg-programmet
	m_cgMulVekVek->loadFragment();
	v0->BindTexture(GL_TEXTURE0_ARB, m_cgMulVekVek->fraPar[0]);
	v1->BindTexture(GL_TEXTURE1_ARB, m_cgMulVekVek->fraPar[1]);
	m_tDraw[VAR]->EnableRead(GL_TEXTURE2_ARB, m_cgMulVekVek->fraPar[2]);
	cgGLSetParameter2f(m_cgMulVekVek->fraPar[4], (GLfloat)(ww), (GLfloat)(hh));
	cgGLSetParameter2f(m_cgMulVekVek->fraPar[5], (GLfloat)(x0), (GLfloat)(y0));
	cgGLSetParameter2f(m_cgMulVekVek->fraPar[6], (GLfloat)(x1), (GLfloat)(y1));
	// cgGLSetParameter1f(m_cgMulVekVek->fraPar[4], faktor);


	// Initialiserer P0 som output
	glDrawBuffer(buf);
	glViewport((int)x, (int)y, 1, 1);
	//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	// glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgMulVekVek->unloadFragment();
	
	// Frst skal jeg gange piksel for piksel
	

	
}
void ParticleSystemGPU::MultiplyI(Draw *res, Draw *IMat, Texture *S, Draw *Vek, int ww, int hh, float faktor)
{
	piksler += ww*hh;
	// Dersom 0 er angitt som fb, antas det at riktig framebuffer er satt
	res->EnableDraw();

	// Laster inn cg-programmet
	m_cgMulIMatVek->loadFragment();
	IMat->EnableRead(GL_TEXTURE0_ARB, m_cgMulIMatVek->fraPar[0]);
	S->BindTexture(GL_TEXTURE1_ARB, m_cgMulIMatVek->fraPar[1]);
	Vek->EnableRead(GL_TEXTURE2_ARB, m_cgMulIMatVek->fraPar[2]);
	
	cgGLSetParameter2f(m_cgMulIMatVek->fraPar[4], (GLfloat)(ww), (GLfloat)(hh));
	
	cgGLSetParameter1f(m_cgMulIMatVek->fraPar[5], faktor);


	// Initialiserer P0 som output
	glViewport(0, 0, w, h);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgMulIMatVek->unloadFragment();
	//////////////SLUTT///////////////////////////////////////
}

void ParticleSystemGPU::Multiply(Draw *res, Draw *MatD, Texture *S, Draw *Vek, int ww, int hh, float faktor)
{
	piksler += ww*hh;
	// Dersom 0 er angitt som fb, antas det at riktig framebuffer er satt
	res->EnableDraw();

	// Laster inn cg-programmet
	m_cgMulSMatVek->loadFragment();
	MatD->EnableRead(GL_TEXTURE0_ARB, GL_TEXTURE1_ARB, GL_TEXTURE2_ARB, m_cgMulSMatVek->fraPar[0], m_cgMulSMatVek->fraPar[1], m_cgMulSMatVek->fraPar[2]);
	// MatL->BindTexture(GL_TEXTURE1_ARB, m_cgMulSMatVek->fraPar[1]);
	S->BindTexture(GL_TEXTURE3_ARB, m_cgMulSMatVek->fraPar[3]);
	Vek->EnableRead(GL_TEXTURE4_ARB, m_cgMulSMatVek->fraPar[4]);
	cgGLSetParameter2f(m_cgMulSMatVek->fraPar[5], (GLfloat)(ww), (GLfloat)(hh));
	cgGLSetParameter2f(m_cgMulSMatVek->fraPar[6], (GLfloat)(26), (GLfloat)(ww*hh));
	cgGLSetParameter1f(m_cgMulSMatVek->fraPar[7], faktor);


	// Initialiserer P0 som output
	glViewport(0, 0, w, h);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgMulSMatVek->unloadFragment();
	//////////////SLUTT///////////////////////////////////////

}


void ParticleSystemGPU::LinkSparse(GLuint fb, GLuint buf, Texture *Mat, int ww, int hh)
{
	//////////////START///////////////////////////////////////
	// Skal linke Mat
/*	m_cgLinkSparse->loadFragment();
	Mat->BindTexture(GL_TEXTURE0_ARB, m_cgLinkSparse->fraPar[0]);
	cgGLSetParameter2f(m_cgLinkSparse->fraPar[1], (GLfloat)(ww*hh), (GLfloat)(3*ww*hh));
	
	glViewport(0, 0, ww*hh, 3*ww*hh);
	

	// Linker 
	glDrawBuffer(buf);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	drawQuad();

	// Laster ut cg-programmet
	m_cgLinkSparse->unloadFragment();*/
	//////////////SLUTT///////////////////////////////////////
}
#ifdef _DEBUG
void ParticleSystemGPU::skrivAlleTeksturerTilFiler()
{
	printf("Skriver teksturer\n");

	GLfloat *tab = new GLfloat[26*3*w*h*4];

	//GLfloat *res = new GLfloat[4*w*h];
	//GLfloat *m = new GLfloat[3*w*h*26*4];
	//GLfloat *v = new GLfloat[w*h*4];
	//les(m_fb[FB_GEN_B], m_buf[B1], w, h, res);
	//les(m_fb[FB_GEN_B], m_buf[B], w, h, v);
	//les(m_fb[FB_DF], m_buf[DFDX], 26, 3*w*h, m);
	////skriv("DFDXTest.txt", 26, 3*w*h, m);

	//printf("SKal gange\n");
	//gange(res, m, v, w, h);
	//printf("Ferdig  gange\n");
	les(m_fb[FB_F], m_buf[F], w, h, tab);	skriv("F.txt", w, h, tab);

	les(m_fb[FB_DF], m_buf[DFDX], 26, 3*w*h, tab);	skriv("DFDX.txt", 26, 3*w*h, tab);
	les(m_fb[FB_DF], m_buf[DFDV], 26, 3*w*h, tab);	skriv("DFDV.txt", 26, 3*w*h, tab);
	// les(m_fb[FB_DF], m_buf[DFDXl], w*h, 3*w*h, tab);	skriv("DFDXl.txt", w*h, 3*w*h, tab);
	
	les(m_fb[FB_GEN_A], m_buf[A], 26, 3*w*h, tab); skriv("A.txt", 26, 3*w*h, tab);
	
	// les(m_fb[FB_GEN_A], m_buf[Al], w*h, 3*w*h, tab); skriv("Al.txt", w*h, 3*w*h, tab);

	les(m_fb[FB_GEN_B], m_buf[B], w, h, tab); skriv("b.txt", w, h, tab);
	les(m_fb[FB_GEN_B], m_buf[B1], w, h, tab); skriv("b1.txt", w, h, tab);
	les(m_fb[FB_GEN_B], m_buf[AP], w, h, tab); skriv("P.txt", w, h, tab);
	les(m_fb[FB_GEN_B], m_buf[AP1], w, h, tab); skriv("P1.txt", w, h, tab);

	les(m_fb[FB_LOOP1], m_buf[VAR], w, h, tab); skriv("Var.txt", w, h, tab);
	les(m_fb[FB_LOOP1], m_buf[QS], w, h, tab); skriv("QS.txt", w, h, tab);
	les(m_fb[FB_LOOP2], m_buf[DV1], w, h, tab); skriv("DV.txt", w, h, tab);


	les(m_fb[FB_BP0], m_buf[P1], w, h, tab); skriv("PosFoer.txt", w, h, tab);
	les(m_fb[FB_BP0], m_buf[P0], w, h, tab); skriv("Pos.txt", w, h, tab);
	les(m_fb[FB_BP1], m_buf[V1], w, h, tab); skriv("VelFoer.txt", w, h, tab);
	les(m_fb[FB_BP1], m_buf[V0], w, h, tab); skriv("Vel.txt", w, h, tab);
	// getchar();
	
	
}
#else
void ParticleSystemGPU::skrivAlleTeksturerTilFiler()
{
}
#endif
void ParticleSystemGPU::les(GLuint fb, GLuint buf, int ww, int hh, GLfloat *tab)
{
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);

	glReadBuffer(buf);
	glReadPixels(0, 0, ww, hh, GL_BGRA_EXT, GL_FLOAT, tab);
}

void ParticleSystemGPU::skriv(char *filnavn, int ww, int hh, GLfloat *tab)
{
	char fil[1000];
	sprintf_s(fil, 1000, "%s%s", "ut-filer\\", filnavn);
	FILE *ut;
	fopen_s(&ut, fil, "w");

	for(int i = 0; i < hh; i++)
	{
		int ipos = i * ww * 4;
		for(int j = 0; j < ww; j++)
		{
			int pos = ipos + j*4;
			fprintf_s(ut, "%d(%3.3lf %3.3lf %3.3lf %3.3lf)\t ", j, tab[pos], tab[pos+1], tab[pos+2], tab[pos+3]);
		}
		fprintf_s(ut, "\n");
	}
	fclose(ut);
}
void ParticleSystemGPU::reset()
{
	GLfloat *pos = new GLfloat[w*h*4]; for(int i = 0; i < w*h*4; i++) pos[i] = 0;//i/4.f;
	GLfloat *blank = new GLfloat[w*h*4];
	
	for(int i = 0; i < 4*w*h; i++) blank[i] = 0;
	
		
	for(int i = 0; i < w; i++)
	{
		for(int j = 0; j < h; j++)
		{
			pos[i*w*4+j*4+0] = (GLfloat)j;
			pos[i*w*4+j*4+1] = (GLfloat)i;			
			pos[i*w*4+j*4+2] = 0;
			pos[i*w*4+j*4+3] = 1;
		}
	}

	glBindTexture(GL_TEXTURE_RECTANGLE_NV, m_tDraw[P0]->m_t->getTID());
	glTexImage2D(GL_TEXTURE_RECTANGLE_NV, 0, GL_FLOAT_RGBA32_NV, w, h, 0, GL_BGRA_EXT, GL_FLOAT, pos);

	glBindTexture(GL_TEXTURE_RECTANGLE_NV, m_tDraw[P1]->m_t->getTID());
	glTexImage2D(GL_TEXTURE_RECTANGLE_NV, 0, GL_FLOAT_RGBA32_NV, w, h, 0, GL_BGRA_EXT, GL_FLOAT, pos);

	glBindTexture(GL_TEXTURE_RECTANGLE_NV, m_tDraw[V0]->m_t->getTID());
	glTexImage2D(GL_TEXTURE_RECTANGLE_NV, 0, GL_FLOAT_RGBA32_NV, w, h, 0, GL_BGRA_EXT, GL_FLOAT, blank);

	glBindTexture(GL_TEXTURE_RECTANGLE_NV, m_tDraw[V1]->m_t->getTID());
	glTexImage2D(GL_TEXTURE_RECTANGLE_NV, 0, GL_FLOAT_RGBA32_NV, w, h, 0, GL_BGRA_EXT, GL_FLOAT, blank);
	
}
#pragma endregion Inneholder standariserte operasjoner

