#pragma once
#include "MatriseBib.h"
#include "testCG.h"
#include "Texture.h"
#include "CGStruct.h"
#include "glErrorUtil.h"
#include "DrawObject.h"
#include <gl\glut.h>
#include <time.h>
#include <math.h>
#include "TestDraw.h"

#define SWAP(c, a, b) { c temp; temp = a; a = b; b = temp; }
#define CheckError(a) { int err151515 = glGetError(); if(err151515) { printf("GL-error(%d): %s\n", err151515, a); getchar(); } }
#define KDEBUG
#define MAX_FB 100
#define MAX_BUFFERS 200
#define INCR_BREAK(nL, sL, nS, sS) { nS++; if(nL == sL && nS == sS) break; }
#define SIGMA 0.00000001
//#define Equals(a, b) ( a - SIGMA < b && b < a + SIGMA)
class ParticleSystemGPU
{
public:
	void testMetoder();
public:
	ParticleSystemGPU(int width, int height);
	int maxIT;
	void reset();
public:
	SMatrise mA;
	Array DVen;
	int piksler;
	~ParticleSystemGPU(void);
	CGStruct *m_cgTegn;
	void iterer();

private: // Metoder som trengs av alle deler
	inline void drawQuad();

private: // Metoder og variable som trengs av beregnKrefter
	inline void beregnKrefter();

	CGStruct	*m_cgBeregnF, 
				*m_cgBeregnDFDX, 
				*m_cgBeregnDFDV;

	Texture		*m_tF, 
				*m_tDFDX0,
				*m_tDFDX1,
				*m_tDFDX2,
				*m_tDFDV0, 
				*m_tDFDV1,
				*m_tDFDV2,				
				*m_tRest;


	
private: // Metoder og variable som trengs av Jacobi
	CGStruct	*m_cgJacobi,
				*m_cgInvert;

	Texture		*m_tInv0,
				*m_tInv1,
				*m_tInv2,
				*m_tInvTest;
	inline void Jacobi(GLfloat delta_tid, int maxIT);
private: // Metoder og variable som trengs av CGSolver
	CGStruct	*m_cgGenererA,
				*m_cgMulSMatVek,
				*m_cgSumVekVek,
				*m_cgMinusVekVek,
				*m_cgMulVekVek,
				*m_cgMulIMatVek,
				*m_cgSumVekVekA,
				*m_cgGenererP,
				*m_cgGenererP1,
				*m_cgSumRekke,
				*m_cgHalver,
				*m_cgMulPiksel,
				*m_cgKopier,
				*m_cgFilter;
	Texture		*m_tB,
				*m_tA0,
				*m_tA1,
				*m_tA2,
				//*m_tAl,
				*m_tB1,
				*m_tS,
				*m_tY,
				*m_tM,
				*m_tAP,
				*m_tAP1,
				*m_tR0,
				*m_tR1,
				*m_tQS,
				*m_tDV0,
				*m_tDV1,
				*m_tC0,
				*m_tC1,
				*m_tVar,
				*m_tHalv0,
				*m_tHalv1;
	inline void CGSolver(GLfloat delta_tid, int maxIT);
	inline void lagP(Draw *ap, Draw *ap1, Draw *A, int ww, int hh);


private: // Metoder og variable som trengs av beregnPosisjon
	inline void beregnPosisjon();

	CGStruct	*m_cgItererV0,	
				*m_cgItererP0;

	Texture		*m_tP0, 
				*m_tV0, 
				*m_tP1, 
				*m_tV1;

	Draw **m_tDraw;
	Texture *m_tAtlas;

	
public: // Metoder og variable som trengs av tegn()
	void tegn(bool test = false);
	CGStruct *m_cgDrawResult;

private:
	int w, h;
	GLfloat ks, kd, dt;

	

	// Multipliserer MatD med Vek, filtrerer resultatet ogs
	/* testet og ser ut til  fungere */
	inline void Multiply(Draw *res, Draw *MatD, Texture *S, Draw *Vek, int ww, int hh, float faktor = 1);

	// Summerer v0 med v1, faktor == 1 --> ganger v1 med alfa, faktor == 2 --> ganger v1 med sNy/sOld
	/* testet og ser ut til  fungere */
	inline void Sum(Draw *res, Draw *v0, Draw *v1, int ww, int hh, int x0=-1, int y0=-1, int x1=-1, int y1=-1);

	// Summerer v0 med v1, ganger resultat med faktor
	/* SumA er testet og ser ut til  fungere */
	inline void SumA(Draw *d, Draw *v0, Draw *v1, int ww, int hh, float faktor);

	// Multipliserer identitetsmatrisen IMat med vektoren Vek, filtrerer resultatet
	/* MultiplyI er testet og ser ut til  fungere */
	inline void MultiplyI(Draw *res, Draw *IMat, Texture *S, Draw *Vek, int ww, int hh, float faktor = 1);

	// regner ut skalarproduktet mellom v0 og v1, legger resultetet i piksel (x, y), a=(x0, y0) og b(x1, y1), ganger resultat med a/b
	/* MultiplyV er testet og ser ut til  fungere */
	inline void MultiplyV(Draw *res, Draw *v0, Draw *v1, int ww, int hh, int x, int y, int x0=-1, int y0=-1, int x1=-1, int y1=-1);
	inline void MultiplyVOld(GLuint, GLuint, Texture *v0, Texture *v1, int ww, int hh, int x, int y, int x0=-1, int y0=-1, int x1=-1, int y1=-1);

	// Subtraherer v1 fra v0, ganger v1 med et oppslag i m_tVar, er faktor 0, ikke gjr noe, er faktor 1, hent frem alfa, er faktor 2, hent frem sigmaNy/sigmaOld
	/* Minus er testet og ser ut til  fungere */
	inline void Minus(Draw *res, Draw *v0, Draw *v1, int ww, int hh, int x0=-1, int y0=-1, int x1=-1, int y1=-1);

	// Obsolete
	inline void LinkSparse(GLuint fb, GLuint buf, Texture *Mat, int w, int h);

	inline void Kopier(Draw *res, Draw *t, int w, int h);

	inline void Filter(Draw *res, Draw *t, Texture *S, int w, int h);

public: // TEST metoder
	void test();

	inline void skrivAlleTeksturerTilFiler();

	inline void les(GLuint fb, GLuint buf, int ww, int hh, GLfloat *tab);

	inline void skriv(char *filnavn, int ww, int hh, GLfloat *tab);

private:
	GLenum m_fb[MAX_FB];
	GLenum m_buf[MAX_BUFFERS];
	enum Buffers
	{
		F=0, 
		DFDX, DFDX0, DFDX1, DFDX2,  
		DFDV, DFDV0, DFDV1, DFDV2,	// Brukt av BeregnKrefter
		P0, V0, 
		P1, V1,						// Brukt av BeregnPosisjon
		A, A0, A1, A2, 					// Hrer til FB_GEN_A
		B, B1, 
		AP, AP1,						// Hrer til FB_GEN_B
		R0, R1, QS,					// Hrer til FB_LOOP0
		VAR,  C0, C1,			// Hrer til FB_LOOP1
		DV0, DV1,					// Hrer til FB_LOOP2
		HALV0, HALV1, ATLAS, Y
	};
	enum FrameBufferObjects
	{
		FB_F=0, 
		FB_DFDX, FB_DFDV,						// Hrer til BeregnKrefter
		FB_BP0, FB_BP1,									// Hrer til BeregnPosisjon
		FB_GEN_B, FB_GEN_AP, FB_GEN_A, FB_LOOP0, FB_LOOP1,	
		FB_LOOP2, // Hrer til CG-solveren
		FB_HALVER, FB_ATLAS,
		FB_INVERT


	};

	
	
};

struct Pixel
{
	GLfloat p[4];
	const Pixel &operator+=(Pixel &p1)
	{
		for(int i = 0; i < 3; i++) p[i] += p1.p[i];
		return *this;
	}
	bool operator==(const Pixel &p1)
	{
		for(int i = 0; i < 3; i++)
		{
			if(!Equals(p[i], p1.p[i])) return false;
		}
		return true;
	}
};
#define MAX(a, b) (a < b ? b : a)
#define MIN(a, b) (a < b ? a : b)

inline Pixel beregn(Pixel &xi, Pixel &xj, Pixel &vi, Pixel &vj, GLfloat ks, GLfloat kd, GLfloat rest)
{
	Pixel res = {0.f, 0.f, 0.f, 0.f};
	Pixel xVek, vVek;
	for(int i = 0; i < 3; i++)
	{
		xVek.p[i] = xi.p[i] - xj.p[i];
		vVek.p[i] = vi.p[i] - vj.p[i];
	}
	GLfloat dot = xVek.p[0]*vVek.p[0] + xVek.p[1]*vVek.p[1] + xVek.p[2]*vVek.p[2];
	GLfloat xLen = sqrt(xVek.p[0]*xVek.p[0] + xVek.p[1]*xVek.p[1] + xVek.p[2]*xVek.p[2]);
	// Fi = -(ks*(vL - rest) +  kd(L*L'/vL))*v / vL
	if(xLen == 0) xLen = 1e-22;
	for(int i = 0; i < 3; i++)
	{
		res.p[i] = -(ks*(xLen-rest) + kd*(dot/xLen))*xVek.p[i] / xLen;
	}
	return res;

}

inline void testF(GLfloat *t_res, GLfloat *t_p0, GLfloat *t_v0, int w, int h, float dt, float ks, float kd, float rest = 1)
{
	Pixel *res = (Pixel*)t_res;
	Pixel *p0 = (Pixel*)t_p0;
	Pixel *v0 = (Pixel*)t_v0;
	
	for(int y = 0; y < h; y++)
	{
		for(int x = 0; x < w; x++)
		{
			for(int i = 0; i < 4; i++) res[y*w+x].p[i] = 0;
			// printf("Tester med ys = (%d-->%d)\n", MAX(MIN(y-2, 0), 0), MIN(MAX(y+2, h), h));
			for(int ys = MAX(y-2, 0); ys < MIN(y+3, h); ys++)
			{
				for(int xs = MAX(x-2, 0); xs < MIN(x+3, w); xs++)
				{
					if(xs == x && ys == y) continue;
					//printf("Kjrer (%d, %d)\n", ys, xs);
					res[y*w+x] += beregn(p0[y*w+x], p0[ys*w+xs], v0[y*w+x], v0[ys*w+xs], ks, kd, rest);
					printf("(%d, %d) = (%lf, %lf, %lf, %lf)\n", y, x, res[y*w+x].p[0], res[y*w+x].p[1], res[y*w+x].p[2], res[y*w+x].p[3]);

				}
			}
		}
	}
}
inline Pixel beregnDFDX(Pixel &xi, Pixel &xj, Pixel &vi, Pixel &vj, GLfloat ks, GLfloat kd)
{
	Pixel res = { 0.f, 0.f, 0.f, 0.f };

	return res;
}
inline void beregnDFDX(GLfloat *t_res, GLfloat *t_p0, GLfloat *t_v0, int w, int h, GLfloat ks, GLfloat kd)
{
	Pixel *res = (Pixel*)t_res;
	Pixel *p0 = (Pixel*)t_p0;
	Pixel *v0 = (Pixel*)t_v0;

	for(int y = 0; y < 3*w*h; y++)
	{
		int xi = (y/3) % w;
		int yi = (y/3) / w;
		for(int x = 1; x < 26; x++)
		{
			int xj = xi + ( (x-1) % 5 - 2);
			int yj = xj + ( (x-1) / 5 - 2);

			res[y*26+x] = beregnDFDX(p0[yi*w+xi], p0[yj*w+xj], v0[yi*w+xi], v0[yj*w+xj], ks, kd);
			
		}
	}
}